/* Title:       ImageProcessing
 * Date:        12/08/98
 * Version:     1.31
 * Authors:     A. Brochard             P. Rolland
 * Email:       abrochard@ices.fr       prolland@free.fr
 */

import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;

class ImageProcessing extends JavaPhotoLab
{
    int[] pix = new int[200002];
    int[] pix2 = new int[200002];
    Image img3;
    int dataset;
    int i;
    int j;
    int c;
    int r;
    int g;
    int b;
    int k;
    int w;
    int h;
    int rgb;
    int br;
    int dim;
    int cote;
    int total;
    int l;
    int m;
    int rtmp;
    int btmp;
    int gtmp;
    int max;
    int p;
    int q;
    int rmax;
    int gmax;
    int bmax;
    int rmin;
    int gmin;
    int bmin;
    int[] c1 = { 16711680, 65280, 255 };
    int[] c2 = { 16, 8, 0 };
    int p1;
    int p2;
    int p3;
    int p4;
    int p5;
    int p6;
    int p7;
    int p8;
    int p9;
    int[] rgbpix = new int[3];
    int[] matfilt = new int[3000];
    int[] rng1 = new int[513];
    int[] rng2 = new int[513];
    double[] tab = new double[462345];
    double val;
    double z;
    double mean;
    double[] mx = new double[7];
    double[] cmax = new double[6];
    int col = 2;
    JavaPhotoLab app;
    int[] tabcolor = { 16711680, 65280, 255 };
    int nbnum;
    int affiche;
    int[] tab2 = new int[100];
    
    public Image Morph(Image image, int i) {
	ImageToMatrix(image);
	int[] is = new int[100];
	int[] is_0_ = new int[100];
	int[] is_1_ = new int[100];
	int i_2_ = 3;
	int i_3_ = 1;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rtmp = 0;
		((ImageProcessing) this).gtmp = 0;
		((ImageProcessing) this).btmp = 0;
		((ImageProcessing) this).k = 0;
		for (((ImageProcessing) this).l = 0;
		     ((ImageProcessing) this).l < i_2_;
		     ((ImageProcessing) this).l++) {
		    for (((ImageProcessing) this).m = 0;
			 ((ImageProcessing) this).m < i_2_;
			 ((ImageProcessing) this).m++) {
			int i_4_ = (((ImageProcessing) this).i
				    + ((ImageProcessing) this).m - i_3_);
			int i_5_ = (((ImageProcessing) this).j
				    + ((ImageProcessing) this).l - i_3_);
			if (i_4_ < 0 || i_4_ >= ((ImageProcessing) this).w
			    || i_5_ < 0
			    || i_5_ >= ((ImageProcessing) this).h) {
			    is[((ImageProcessing) this).k] = 1000;
			    is_0_[((ImageProcessing) this).k] = 1000;
			    is_1_[((ImageProcessing) this).k] = 1000;
			} else {
			    ((ImageProcessing) this).rgb
				= (((ImageProcessing) this).pix
				   [i_5_ * ((ImageProcessing) this).w + i_4_]);
			    is[((ImageProcessing) this).k]
				= ((((ImageProcessing) this).rgb & 0xff0000)
				   >> 16);
			    is_0_[((ImageProcessing) this).k]
				= (((ImageProcessing) this).rgb & 0xff00) >> 8;
			    is_1_[((ImageProcessing) this).k]
				= ((ImageProcessing) this).rgb & 0xff;
			}
			((ImageProcessing) this).k++;
		    }
		}
		((ImageProcessing) this).rmax = 0;
		((ImageProcessing) this).gmax = 0;
		((ImageProcessing) this).bmax = 0;
		((ImageProcessing) this).rmin = 300;
		((ImageProcessing) this).gmin = 300;
		((ImageProcessing) this).bmin = 300;
		for (((ImageProcessing) this).k = 0;
		     ((ImageProcessing) this).k < 9;
		     ((ImageProcessing) this).k++) {
		    if ((is[((ImageProcessing) this).k]
			 > ((ImageProcessing) this).rmax)
			&& is[((ImageProcessing) this).k] != 1000)
			((ImageProcessing) this).rmax
			    = is[((ImageProcessing) this).k];
		    if ((is_0_[((ImageProcessing) this).k]
			 > ((ImageProcessing) this).gmax)
			&& is_0_[((ImageProcessing) this).k] != 1000)
			((ImageProcessing) this).gmax
			    = is_0_[((ImageProcessing) this).k];
		    if ((is_1_[((ImageProcessing) this).k]
			 > ((ImageProcessing) this).bmax)
			&& is_1_[((ImageProcessing) this).k] != 1000)
			((ImageProcessing) this).bmax
			    = is_1_[((ImageProcessing) this).k];
		}
		for (((ImageProcessing) this).k = 0;
		     ((ImageProcessing) this).k < 9;
		     ((ImageProcessing) this).k++) {
		    if ((is[((ImageProcessing) this).k]
			 < ((ImageProcessing) this).rmin)
			&& is[((ImageProcessing) this).k] != 1000)
			((ImageProcessing) this).rmin
			    = is[((ImageProcessing) this).k];
		    if ((is_0_[((ImageProcessing) this).k]
			 < ((ImageProcessing) this).gmin)
			&& is_0_[((ImageProcessing) this).k] != 1000)
			((ImageProcessing) this).gmin
			    = is_0_[((ImageProcessing) this).k];
		    if ((is_1_[((ImageProcessing) this).k]
			 < ((ImageProcessing) this).bmin)
			&& is_1_[((ImageProcessing) this).k] != 1000)
			((ImageProcessing) this).bmin
			    = is_1_[((ImageProcessing) this).k];
		}
		if (i == 1) {
		    ((ImageProcessing) this).r = ((ImageProcessing) this).rmax;
		    ((ImageProcessing) this).g = ((ImageProcessing) this).gmax;
		    ((ImageProcessing) this).b = ((ImageProcessing) this).bmax;
		} else if (i == 2) {
		    ((ImageProcessing) this).r = ((ImageProcessing) this).rmin;
		    ((ImageProcessing) this).g = ((ImageProcessing) this).gmin;
		    ((ImageProcessing) this).b = ((ImageProcessing) this).bmin;
		} else if (i == 3) {
		    ((ImageProcessing) this).r
			= (((ImageProcessing) this).rmax
			   - ((ImageProcessing) this).rmin) / 2;
		    ((ImageProcessing) this).g
			= (((ImageProcessing) this).gmax
			   - ((ImageProcessing) this).gmin) / 2;
		    ((ImageProcessing) this).b
			= (((ImageProcessing) this).bmax
			   - ((ImageProcessing) this).bmin) / 2;
		} else if (i == 4) {
		    ((ImageProcessing) this).r
			= ((((ImageProcessing) this).rmax
			    + ((ImageProcessing) this).rmin - 2 * is[4]) / 2
			   + 128);
		    ((ImageProcessing) this).g
			= ((((ImageProcessing) this).gmax
			    + ((ImageProcessing) this).gmin - 2 * is[4]) / 2
			   + 128);
		    ((ImageProcessing) this).b
			= ((((ImageProcessing) this).bmax
			    + ((ImageProcessing) this).bmin - 2 * is[4]) / 2
			   + 128);
		}
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = ((((ImageProcessing) this).pix
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]) & ~0xffffff
		       | ((ImageProcessing) this).r << 16
		       | ((ImageProcessing) this).g << 8
		       | ((ImageProcessing) this).b);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public ImageProcessing(JavaPhotoLab a, int st, String copy) {
	((ImageProcessing) this).app = a;
	if (st != 31415926 || !copy.equals("java/awt"))
	    System.exit(0);
    }
    
    public void LinearFilter() {
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rtmp = 0;
		((ImageProcessing) this).gtmp = 0;
		((ImageProcessing) this).btmp = 0;
		for (((ImageProcessing) this).l = 0;
		     ((ImageProcessing) this).l < ((ImageProcessing) this).dim;
		     ((ImageProcessing) this).l++) {
		    for (((ImageProcessing) this).m = 0;
			 (((ImageProcessing) this).m
			  < ((ImageProcessing) this).dim);
			 ((ImageProcessing) this).m++) {
			int xf = (((ImageProcessing) this).i
				  + ((ImageProcessing) this).m
				  - ((ImageProcessing) this).cote);
			int yf = (((ImageProcessing) this).j
				  + ((ImageProcessing) this).l
				  - ((ImageProcessing) this).cote);
			if (xf >= 0 && xf < ((ImageProcessing) this).w
			    && yf >= 0 && yf < ((ImageProcessing) this).h) {
			    ((ImageProcessing) this).rgb
				= (((ImageProcessing) this).pix
				   [yf * ((ImageProcessing) this).w + xf]);
			    ((ImageProcessing) this).rtmp
				= (((ImageProcessing) this).rtmp
				   + (((((ImageProcessing) this).rgb
					& 0xff0000)
				       >> 16)
				      * (((ImageProcessing) this).matfilt
					 [((((ImageProcessing) this).l
					    * ((ImageProcessing) this).dim)
					   + ((ImageProcessing) this).m)])));
			    ((ImageProcessing) this).gtmp
				= (((ImageProcessing) this).gtmp
				   + (((((ImageProcessing) this).rgb & 0xff00)
				       >> 8)
				      * (((ImageProcessing) this).matfilt
					 [((((ImageProcessing) this).l
					    * ((ImageProcessing) this).dim)
					   + ((ImageProcessing) this).m)])));
			    ((ImageProcessing) this).btmp
				= (((ImageProcessing) this).btmp
				   + ((((ImageProcessing) this).rgb & 0xff)
				      * (((ImageProcessing) this).matfilt
					 [((((ImageProcessing) this).l
					    * ((ImageProcessing) this).dim)
					   + ((ImageProcessing) this).m)])));
			}
		    }
		}
		((ImageProcessing) this).rtmp
		    = (((ImageProcessing) this).rtmp
		       / ((ImageProcessing) this).total);
		((ImageProcessing) this).btmp
		    = (((ImageProcessing) this).btmp
		       / ((ImageProcessing) this).total);
		((ImageProcessing) this).gtmp
		    = (((ImageProcessing) this).gtmp
		       / ((ImageProcessing) this).total);
		if (((ImageProcessing) this).rtmp < 0)
		    ((ImageProcessing) this).rtmp = 0;
		if (((ImageProcessing) this).gtmp < 0)
		    ((ImageProcessing) this).gtmp = 0;
		if (((ImageProcessing) this).btmp < 0)
		    ((ImageProcessing) this).btmp = 0;
		if (((ImageProcessing) this).rtmp > 255)
		    ((ImageProcessing) this).rtmp = 255;
		if (((ImageProcessing) this).gtmp > 255)
		    ((ImageProcessing) this).gtmp = 255;
		if (((ImageProcessing) this).btmp > 255)
		    ((ImageProcessing) this).btmp = 255;
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = ((((ImageProcessing) this).pix
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]) & ~0xffffff
		       | ((ImageProcessing) this).rtmp << 16
		       | ((ImageProcessing) this).gtmp << 8
		       | ((ImageProcessing) this).btmp);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
    }
    
    public Image BiLinearInterpolation(Image img) {
	int[] filt = { 1, 2, 3, 4, 3, 2, 1, 2, 4, 6, 8, 6, 4, 2, 3, 6, 9, 12,
		       9, 6, 3, 4, 8, 12, 16, 12, 8, 4, 3, 6, 9, 12, 9, 6, 3,
		       2, 4, 6, 8, 6, 4, 2, 1, 2, 3, 4, 3, 2, 1 };
	ImageToMatrix(img);
	((ImageProcessing) this).dim = 7;
	((ImageProcessing) this).cote = 3;
	((ImageProcessing) this).total = 16;
	for (((ImageProcessing) this).i = 0;
	     (((ImageProcessing) this).i
	      < ((ImageProcessing) this).dim * ((ImageProcessing) this).dim);
	     ((ImageProcessing) this).i++)
	    ((ImageProcessing) this).matfilt[((ImageProcessing) this).i]
		= filt[((ImageProcessing) this).i];
	LinearFilter();
	return MatrixToImage();
    }
    
    public Image Treshold(Image img, double value1) {
	ImageToMatrix(img);
	int seuil = (int) value1;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		((ImageProcessing) this).r
		    = (((ImageProcessing) this).rgb & 0xff0000) >> 16;
		if (((ImageProcessing) this).r > seuil)
		    ((ImageProcessing) this).r = 255;
		else
		    ((ImageProcessing) this).r = 0;
		((ImageProcessing) this).g
		    = (((ImageProcessing) this).rgb & 0xff00) >> 8;
		if (((ImageProcessing) this).g > seuil)
		    ((ImageProcessing) this).g = 255;
		else
		    ((ImageProcessing) this).g = 0;
		((ImageProcessing) this).b
		    = ((ImageProcessing) this).rgb & 0xff;
		if (((ImageProcessing) this).b > seuil)
		    ((ImageProcessing) this).b = 255;
		else
		    ((ImageProcessing) this).b = 0;
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = ((((ImageProcessing) this).pix
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]) & ~0xffffff
		       | ((ImageProcessing) this).r << 16
		       | ((ImageProcessing) this).g << 8
		       | ((ImageProcessing) this).b);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image GaussianWiener(Image image, double d, double d_6_) {
	ImageToMatrix(image);
	double d_7_ = d;
	double d_8_ = 1.0 / Math.pow(d_6_, 10.0);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).j++) {
		double d_9_
		    = (Math.sqrt
		       (Math.pow((double) (((ImageProcessing) this).i
					   - ((ImageProcessing) this).w / 2),
				 2.0)
			+ Math.pow((double) (((ImageProcessing) this).j
					     - ((ImageProcessing) this).h / 2),
				   2.0)));
		double d_10_ = Math.exp(-0.5 * Math.pow(d_9_ / d_7_, 2.0));
		double d_11_ = d_10_ / (d_10_ * d_10_ + d_8_);
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		for (((ImageProcessing) this).c = 0;
		     ((ImageProcessing) this).c < ((ImageProcessing) this).col;
		     ((ImageProcessing) this).c
			 = ((ImageProcessing) this).c + 2) {
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_11_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_11_;
		    ((ImageProcessing) this).rgbpix[(((ImageProcessing) this).c
						     / 2)]
			= (int) ((double) ((((ImageProcessing) this).rgb
					    & (((ImageProcessing) this)
					       .tabcolor
					       [(((ImageProcessing) this).c
						 / 2)]))
					   >> 16 - (((ImageProcessing) this).c
						    * 4))
				 * d_11_);
		}
		if (((ImageProcessing) this).col == 6)
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		else
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[0] << 8
			   | ((ImageProcessing) this).rgbpix[0]);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image Cartoon(Image img) {
	ImageToMatrix(img);
	int[] rgbpix2 = new int[3];
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		if (((ImageProcessing) this).i == 0
		    || (((ImageProcessing) this).i
			== ((ImageProcessing) this).w - 1)
		    || ((ImageProcessing) this).j == 0
		    || (((ImageProcessing) this).j
			== ((ImageProcessing) this).h - 1))
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= (((ImageProcessing) this).pix
			   [((((ImageProcessing) this).j
			      * ((ImageProcessing) this).w)
			     + ((ImageProcessing) this).i)]);
		else {
		    for (((ImageProcessing) this).c = 0;
			 ((ImageProcessing) this).c < 3;
			 ((ImageProcessing) this).c++) {
			((ImageProcessing) this).p1
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j - 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i - 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p2
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j - 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p3
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j - 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i + 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p4
			    = (((((ImageProcessing) this).pix
				 [((((ImageProcessing) this).j
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i - 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p5
			    = (((((ImageProcessing) this).pix
				 [((((ImageProcessing) this).j
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p6
			    = (((((ImageProcessing) this).pix
				 [((((ImageProcessing) this).j
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i + 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p7
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j + 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i - 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p8
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j + 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p9
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j + 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i + 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).r
			    = (((ImageProcessing) this).p1
			       + 2 * ((ImageProcessing) this).p4
			       + ((ImageProcessing) this).p7
			       - ((ImageProcessing) this).p3
			       - 2 * ((ImageProcessing) this).p6
			       - ((ImageProcessing) this).p9);
			((ImageProcessing) this).g
			    = (((ImageProcessing) this).p1
			       + 2 * ((ImageProcessing) this).p2
			       + ((ImageProcessing) this).p3
			       - ((ImageProcessing) this).p7
			       - 2 * ((ImageProcessing) this).p8
			       - ((ImageProcessing) this).p9);
			rgbpix2[((ImageProcessing) this).c]
			    = (int) (Math.sqrt
				     ((double) (((((ImageProcessing) this).r
						  * ((ImageProcessing) this).r)
						 + (((ImageProcessing) this).g
						    * (((ImageProcessing) this)
						       .g)))
						/ 9)));
			((ImageProcessing) this).rgbpix
			    [((ImageProcessing) this).c]
			    = ((ImageProcessing) this).p5;
		    }
		    ((ImageProcessing) this).l = 0;
		    for (((ImageProcessing) this).c = 0;
			 ((ImageProcessing) this).c < 3;
			 ((ImageProcessing) this).c++) {
			if (rgbpix2[((ImageProcessing) this).c]
			    > ((ImageProcessing) this).l)
			    ((ImageProcessing) this).l
				= rgbpix2[((ImageProcessing) this).c];
		    }
		    ((ImageProcessing) this).val
			= (double) ((ImageProcessing) this).l;
		    ((ImageProcessing) this).val
			= 1.0 - ((ImageProcessing) this).val / 255.0;
		    for (((ImageProcessing) this).c = 0;
			 ((ImageProcessing) this).c < 3;
			 ((ImageProcessing) this).c++)
			((ImageProcessing) this).rgbpix
			    [((ImageProcessing) this).c]
			    = (int) Math.abs((double) (((ImageProcessing) this)
						       .rgbpix
						       [((ImageProcessing)
							 this).c])
					     * ((ImageProcessing) this).val);
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		}
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public boolean isFFT(int wi, int he) {
	double ln1
	    = (double) (int) Math.round(Math.log((double) wi) / Math.log(2.0));
	double ln2
	    = (double) (int) Math.round(Math.log((double) he) / Math.log(2.0));
	if ((double) Math.round(ln1) == ln1 && (double) Math.round(ln1) == ln1
	    && ln1 == ln2)
	    return true;
	return false;
    }
    
    public Image Center(Image img) {
	ImageToMatrix(img);
	int supx = ((ImageProcessing) this).w / 2;
	int supy = ((ImageProcessing) this).h / 2;
	for (((ImageProcessing) this).i = 0; ((ImageProcessing) this).i < 256;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < 256;
		 ((ImageProcessing) this).j++) {
		if (((ImageProcessing) this).i >= 128 + supx
		    || ((ImageProcessing) this).j >= 128 + supy
		    || ((ImageProcessing) this).i < 128 - supx
		    || ((ImageProcessing) this).j < 128 - supy)
		    ((ImageProcessing) this).rgb
			= ((ImageProcessing) this).rgb & ~0xffffff | 0x0;
		else
		    ((ImageProcessing) this).rgb
			= (((ImageProcessing) this).pix
			   [(((((ImageProcessing) this).j - (128 - supy))
			      * ((ImageProcessing) this).w)
			     + ((ImageProcessing) this).i - (128 - supx))]);
		((ImageProcessing) this).pix2[(((ImageProcessing) this).j * 256
					       + ((ImageProcessing) this).i)]
		    = ((ImageProcessing) this).rgb;
	    }
	}
	((ImageProcessing) this).w = 256;
	((ImageProcessing) this).h = 256;
	return MatrixToImage();
    }
    
    public Image DeCenter(Image img, double value1, double value2) {
	ImageToMatrix(img);
	((ImageProcessing) this).w = (int) value1;
	((ImageProcessing) this).h = (int) value2;
	int supx = 128 - ((ImageProcessing) this).w / 2;
	int supy = 128 - ((ImageProcessing) this).h / 2;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j + supy) * 256
			 + ((ImageProcessing) this).i + supx)]);
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = ((ImageProcessing) this).rgb;
	    }
	}
	return MatrixToImage();
    }
    
    public Image Posterize(Image img, double value1) {
	ImageToMatrix(img);
	int post = (int) value1;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		((ImageProcessing) this).r
		    = (((ImageProcessing) this).rgb & 0xff0000) >> 16;
		((ImageProcessing) this).g
		    = (((ImageProcessing) this).rgb & 0xff00) >> 8;
		((ImageProcessing) this).b
		    = ((ImageProcessing) this).rgb & 0xff;
		((ImageProcessing) this).r
		    = (int) ((long) (256 / post)
			     * Math.round((double) (((ImageProcessing) this).r
						    * post / 256)));
		((ImageProcessing) this).g
		    = (int) ((long) (256 / post)
			     * Math.round((double) (((ImageProcessing) this).g
						    * post / 256)));
		((ImageProcessing) this).b
		    = (int) ((long) (256 / post)
			     * Math.round((double) (((ImageProcessing) this).b
						    * post / 256)));
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = ((((ImageProcessing) this).pix
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]) & ~0xffffff
		       | ((ImageProcessing) this).r << 16
		       | ((ImageProcessing) this).g << 8
		       | ((ImageProcessing) this).b);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image DCT(Image image, double d) {
	int[] is = { 16, 11, 10, 16, 24, 40, 51, 61, 12, 12, 14, 19, 26, 58,
		     60, 55, 14, 13, 16, 24, 40, 57, 69, 56, 14, 17, 22, 29,
		     51, 87, 80, 62, 18, 22, 37, 56, 68, 109, 103, 77, 24, 35,
		     55, 64, 81, 104, 113, 92, 49, 64, 78, 87, 103, 121, 120,
		     101, 72, 92, 95, 98, 112, 100, 103, 99 };
	double d_12_ = d / 20.0;
	double[][] ds = new double[65][65];
	ImageToMatrix(image);
	((ImageProcessing) this).nbnum = 0;
	int i = 0;
	do {
	    int i_13_ = 0;
	    do {
		int i_14_ = 0;
		do {
		    int i_15_ = 0;
		    do {
			double d_16_;
			if (i == 0)
			    d_16_ = 1.0 / Math.sqrt(2.0);
			else
			    d_16_ = 1.0;
			if (i_13_ == 0)
			    d_16_ /= Math.sqrt(2.0);
			ds[i_13_ * 8 + i][i_15_ * 8 + i_14_]
			    = (d_16_
			       * Math.cos((double) ((2 * i_14_ + 1) * i)
					  * 3.141592653589793 / 16.0)
			       * Math.cos((double) ((2 * i_15_ + 1) * i_13_)
					  * 3.141592653589793 / 16.0)
			       / 4.0);
		    } while (++i_15_ < 8);
		} while (++i_14_ < 8);
	    } while (++i_13_ < 8);
	} while (++i < 8);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i = ((ImageProcessing) this).i + 8) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j = ((ImageProcessing) this).j + 8) {
		i = 0;
		do {
		    int i_17_ = 0;
		    do {
			double d_18_ = 0.0;
			int i_19_ = 0;
			do {
			    int i_20_ = 0;
			    do {
				((ImageProcessing) this).rgb
				    = ((((ImageProcessing) this).pix
					[(((((ImageProcessing) this).j + i_20_)
					   * ((ImageProcessing) this).w)
					  + ((ImageProcessing) this).i
					  + i_19_)])
				       & 0xff0000) >> 16;
				d_18_ += ((double) ((ImageProcessing) this).rgb
					  * (ds[i_17_ * 8 + i]
					     [i_20_ * 8 + i_19_]));
			    } while (++i_20_ < 8);
			} while (++i_19_ < 8);
			((ImageProcessing) this).tab
			    [(((ImageProcessing) this).col
			      * (((((ImageProcessing) this).j + i_17_)
				  * ((ImageProcessing) this).w)
				 + ((ImageProcessing) this).i + i)) + 0]
			    = d_18_;
		    } while (++i_17_ < 8);
		} while (++i < 8);
		i = 0;
		do {
		    int i_21_ = 0;
		    do
			((ImageProcessing) this).tab
			    [(((ImageProcessing) this).col
			      * (((((ImageProcessing) this).j + i_21_)
				  * ((ImageProcessing) this).w)
				 + ((ImageProcessing) this).i + i)) + 0]
			    = (double) (Math.round
					((((ImageProcessing) this).tab
					  [(((ImageProcessing) this).col
					    * (((((ImageProcessing) this).j
						 + i_21_)
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i
					       + i)) + 0])
					 / (d_12_
					    * (double) is[i_21_ * 8 + i])));
		    while (++i_21_ < 8);
		} while (++i < 8);
		i = 0;
		do {
		    int i_22_ = 0;
		    do {
			((ImageProcessing) this).tab
			    [(((ImageProcessing) this).col
			      * (((((ImageProcessing) this).j + i_22_)
				  * ((ImageProcessing) this).w)
				 + ((ImageProcessing) this).i + i)) + 0]
			    = (d_12_ * (double) is[i_22_ * 8 + i]
			       * (((ImageProcessing) this).tab
				  [((((ImageProcessing) this).col
				     * (((((ImageProcessing) this).j + i_22_)
					 * ((ImageProcessing) this).w)
					+ ((ImageProcessing) this).i + i))
				    + 0)]));
			if ((((ImageProcessing) this).tab
			     [(((ImageProcessing) this).col
			       * (((((ImageProcessing) this).j + i_22_)
				   * ((ImageProcessing) this).w)
				  + ((ImageProcessing) this).i + i)) + 0])
			    != 0.0)
			    ((ImageProcessing) this).nbnum++;
		    } while (++i_22_ < 8);
		} while (++i < 8);
		int i_23_ = 0;
		do {
		    int i_24_ = 0;
		    do {
			double d_25_ = 0.0;
			i = 0;
			do {
			    int i_26_ = 0;
			    do
				d_25_ += ((((ImageProcessing) this).tab
					   [(((ImageProcessing) this).col
					     * (((((ImageProcessing) this).j
						  + i_26_)
						 * ((ImageProcessing) this).w)
						+ ((ImageProcessing) this).i
						+ i)) + 0])
					  * (ds[i_26_ * 8 + i]
					     [i_24_ * 8 + i_23_]));
			    while (++i_26_ < 8);
			} while (++i < 8);
			((ImageProcessing) this).tab
			    [(((ImageProcessing) this).col
			      * (((((ImageProcessing) this).j + i_24_)
				  * ((ImageProcessing) this).w)
				 + ((ImageProcessing) this).i + i_23_)) + 1]
			    = d_25_;
		    } while (++i_24_ < 8);
		} while (++i_23_ < 8);
		i_23_ = 0;
		do {
		    int i_27_ = 0;
		    do {
			((ImageProcessing) this).rgb
			    = (int) (Math.round
				     (((ImageProcessing) this).tab
				      [(((ImageProcessing) this).col
					* (((((ImageProcessing) this).j
					     + i_27_)
					    * ((ImageProcessing) this).w)
					   + ((ImageProcessing) this).i
					   + i_23_)) + 1]));
			((ImageProcessing) this).pix2
			    [(((((ImageProcessing) this).j + i_27_)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + i_23_)]
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j + i_27_)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i + i_23_)])
				& ~0xffffff)
			       | ((ImageProcessing) this).rgb << 16
			       | ((ImageProcessing) this).rgb << 8
			       | ((ImageProcessing) this).rgb);
		    } while (++i_27_ < 8);
		} while (++i_23_ < 8);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	((ImageProcessing) this).affiche = 1;
	return MatrixToImage();
    }
    
    public void initcalc(int n) {
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i <= n - 1; ((ImageProcessing) this).i++)
	    ((ImageProcessing) this).rng1[((ImageProcessing) this).i + 1]
		= ((ImageProcessing) this).i;
	for (int bcl = 1; bcl <= n; bcl = 2 * bcl) {
	    int divi = n / bcl;
	    ((ImageProcessing) this).j = 0;
	    for (((ImageProcessing) this).k = 0;
		 ((ImageProcessing) this).k <= bcl - 1;
		 ((ImageProcessing) this).k++) {
		for (((ImageProcessing) this).i
			 = divi * ((ImageProcessing) this).k;
		     (((ImageProcessing) this).i
		      <= divi * (((ImageProcessing) this).k + 1) - 1);
		     ((ImageProcessing) this).i++) {
		    if (((ImageProcessing) this).i % 2 == 0) {
			((ImageProcessing) this).rng2
			    [((ImageProcessing) this).j + 1]
			    = (((ImageProcessing) this).rng1
			       [((ImageProcessing) this).i + 1]);
			((ImageProcessing) this).j
			    = ((ImageProcessing) this).j + 1;
		    }
		}
		for (((ImageProcessing) this).i
			 = divi * ((ImageProcessing) this).k;
		     (((ImageProcessing) this).i
		      <= divi * (((ImageProcessing) this).k + 1) - 1);
		     ((ImageProcessing) this).i++) {
		    if (((ImageProcessing) this).i % 2 == 1) {
			((ImageProcessing) this).rng2
			    [((ImageProcessing) this).j + 1]
			    = (((ImageProcessing) this).rng1
			       [((ImageProcessing) this).i + 1]);
			((ImageProcessing) this).j
			    = ((ImageProcessing) this).j + 1;
		    }
		}
	    }
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i <= n - 1;
		 ((ImageProcessing) this).i++)
		((ImageProcessing) this).rng1[((ImageProcessing) this).i + 1]
		    = (((ImageProcessing) this).rng2
		       [((ImageProcessing) this).i + 1]);
	}
    }
    
    public Image RL(Image image, double d, double d_28_) {
	ImageToMatrix(image);
	int i = (int) d;
	int i_29_ = 0;
	int i_30_ = 132099;
	int i_31_ = 264197;
	int i_32_ = 396295;
	double d_33_ = 0.0;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		int i_34_ = (((ImageProcessing) this).col
			     * (((((ImageProcessing) this).j + 1)
				 * ((ImageProcessing) this).w)
				+ ((ImageProcessing) this).i + 1));
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]) & 0xff;
		((ImageProcessing) this).tab[i_34_ + i_31_]
		    = (double) ((ImageProcessing) this).rgb / 255.0;
		((ImageProcessing) this).tab[i_34_ + 1 + i_31_] = 0.0;
		d_33_ += ((ImageProcessing) this).tab[i_34_ + i_31_];
	    }
	}
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		int i_35_ = (((ImageProcessing) this).col
			     * (((((ImageProcessing) this).j + 1)
				 * ((ImageProcessing) this).w)
				+ ((ImageProcessing) this).i + 1));
		((ImageProcessing) this).tab[i_35_ + i_29_]
		    = d_33_ / (double) (((ImageProcessing) this).w
					* ((ImageProcessing) this).h);
		((ImageProcessing) this).tab[i_35_ + 1 + i_29_] = 0.0;
	    }
	}
	for (int i_36_ = 0; i_36_ < i; i_36_++) {
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int i_37_ = (((ImageProcessing) this).col
				 * (((((ImageProcessing) this).j + 1)
				     * ((ImageProcessing) this).w)
				    + ((ImageProcessing) this).i + 1));
		    ((ImageProcessing) this).tab[i_37_ + i_30_]
			= ((ImageProcessing) this).tab[i_37_ + i_29_];
		    ((ImageProcessing) this).tab[i_37_ + 1 + i_30_]
			= ((ImageProcessing) this).tab[i_37_ + 1 + i_29_];
		}
	    }
	    ((ImageProcessing) this).dataset = i_30_;
	    FFT(image, 1, 1, true, "Iteration: " + (i_36_ + 1) + " ; ");
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		     ((ImageProcessing) this).j++) {
		    double d_38_
			= (Math.sqrt
			   (Math.pow((double) (((ImageProcessing) this).i
					       - (((ImageProcessing) this).w
						  / 2)),
				     2.0)
			    + Math.pow((double) (((ImageProcessing) this).j
						 - (((ImageProcessing) this).h
						    / 2)),
				       2.0)));
		    double d_39_
			= Math.exp(-0.5 * Math.pow(d_38_ / d_28_, 2.0));
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).dataset)]
			*= d_39_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).dataset)]
			*= d_39_;
		}
	    }
	    FFT(image, -1, 1, true, "Iteration: " + (i_36_ + 1) + " ; ");
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int i_40_ = (((ImageProcessing) this).col
				 * (((((ImageProcessing) this).j + 1)
				     * ((ImageProcessing) this).w)
				    + ((ImageProcessing) this).i + 1));
		    if (((ImageProcessing) this).tab[i_40_ + i_30_] != 0.0)
			((ImageProcessing) this).tab[i_40_ + i_30_]
			    = (((ImageProcessing) this).tab[i_40_ + i_31_]
			       / ((ImageProcessing) this).tab[i_40_ + i_30_]);
		    ((ImageProcessing) this).tab[i_40_ + 1 + i_30_] = 0.0;
		}
	    }
	    ((ImageProcessing) this).mx[0] = 0.0;
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int i_41_ = ((((ImageProcessing) this).col
				  * (((((ImageProcessing) this).j + 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i + 1))
				 + ((ImageProcessing) this).dataset);
		    ((ImageProcessing) this).val
			= Math.sqrt((((ImageProcessing) this).tab[i_41_]
				     * ((ImageProcessing) this).tab[i_41_])
				    + (((ImageProcessing) this).tab[i_41_ + 1]
				       * (((ImageProcessing) this).tab
					  [i_41_ + 1])));
		    if (((ImageProcessing) this).val
			> ((ImageProcessing) this).mx[0])
			((ImageProcessing) this).mx[0]
			    = ((ImageProcessing) this).val;
		}
	    }
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int i_42_ = ((((ImageProcessing) this).col
				  * (((((ImageProcessing) this).j + 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i + 1))
				 + ((ImageProcessing) this).dataset);
		    ((ImageProcessing) this).val
			= Math.sqrt((((ImageProcessing) this).tab[i_42_]
				     * ((ImageProcessing) this).tab[i_42_])
				    + (((ImageProcessing) this).tab[i_42_ + 1]
				       * (((ImageProcessing) this).tab
					  [i_42_ + 1])));
		    ((ImageProcessing) this).tab[i_42_]
			= (((ImageProcessing) this).val
			   / ((ImageProcessing) this).mx[0]);
		}
	    }
	    ((ImageProcessing) this).dataset = i_30_;
	    FFT(image, 1, 1, true, "Iteration: " + (i_36_ + 1) + " ; ");
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		     ((ImageProcessing) this).j++) {
		    double d_43_
			= (Math.sqrt
			   (Math.pow((double) (((ImageProcessing) this).i
					       - (((ImageProcessing) this).w
						  / 2)),
				     2.0)
			    + Math.pow((double) (((ImageProcessing) this).j
						 - (((ImageProcessing) this).h
						    / 2)),
				       2.0)));
		    double d_44_
			= Math.exp(-0.5 * Math.pow(d_43_ / d_28_, 2.0));
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).dataset)]
			*= d_44_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).dataset)]
			*= d_44_;
		}
	    }
	    FFT(image, -1, 1, true, "Iteration: " + (i_36_ + 1) + " ; ");
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int i_45_ = (((ImageProcessing) this).col
				 * (((((ImageProcessing) this).j + 1)
				     * ((ImageProcessing) this).w)
				    + ((ImageProcessing) this).i + 1));
		    ((ImageProcessing) this).tab[i_45_ + i_29_]
			= (((ImageProcessing) this).tab[i_45_ + i_29_]
			   * ((ImageProcessing) this).tab[i_45_ + i_30_]);
		    ((ImageProcessing) this).tab[i_45_ + 1 + i_29_] = 0.0;
		}
	    }
	    ((ImageProcessing) this).mx[0] = 0.0;
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int i_46_ = ((((ImageProcessing) this).col
				  * (((((ImageProcessing) this).j + 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i + 1))
				 + i_29_);
		    ((ImageProcessing) this).val
			= Math.sqrt((((ImageProcessing) this).tab[i_46_]
				     * ((ImageProcessing) this).tab[i_46_])
				    + (((ImageProcessing) this).tab[i_46_ + 1]
				       * (((ImageProcessing) this).tab
					  [i_46_ + 1])));
		    if (((ImageProcessing) this).val
			> ((ImageProcessing) this).mx[0])
			((ImageProcessing) this).mx[0]
			    = ((ImageProcessing) this).val;
		}
	    }
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int i_47_ = ((((ImageProcessing) this).col
				  * (((((ImageProcessing) this).j + 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i + 1))
				 + i_29_);
		    ((ImageProcessing) this).val
			= Math.sqrt((((ImageProcessing) this).tab[i_47_]
				     * ((ImageProcessing) this).tab[i_47_])
				    + (((ImageProcessing) this).tab[i_47_ + 1]
				       * (((ImageProcessing) this).tab
					  [i_47_ + 1])));
		    ((ImageProcessing) this).tab[i_47_]
			= (((ImageProcessing) this).val
			   / ((ImageProcessing) this).mx[0]);
		    ((ImageProcessing) this).r
			= (int) Math.round(255.0 * (((ImageProcessing) this)
						    .tab[i_47_]));
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).r << 16
			   | ((ImageProcessing) this).r << 8
			   | ((ImageProcessing) this).r);
		}
	    }
	    int i_48_;
	    if (i < 10)
		i_48_ = 2;
	    else
		i_48_ = i / 5;
	    if (i_36_ < i - 1 && i_36_ % i_48_ == 0)
		((ImageProcessing) this).app.Addimg(MatrixToImage());
	}
	return MatrixToImage();
    }
    
    public Image Brightness(Image img, int k) {
	ImageToMatrix(img);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		if (k >= 0) {
		    ((ImageProcessing) this).br = k;
		    ((ImageProcessing) this).r
			= ((ImageProcessing) this).rgb & 0xff0000;
		    if (((ImageProcessing) this).r
			> 16711680 - (((ImageProcessing) this).br << 16))
			((ImageProcessing) this).r = 16711680;
		    else
			((ImageProcessing) this).r
			    = (((ImageProcessing) this).r
			       + (((ImageProcessing) this).br << 16));
		    ((ImageProcessing) this).g
			= ((ImageProcessing) this).rgb & 0xff00;
		    if (((ImageProcessing) this).g
			> 65280 - (((ImageProcessing) this).br << 8))
			((ImageProcessing) this).g = 65280;
		    else
			((ImageProcessing) this).g
			    = (((ImageProcessing) this).g
			       + (((ImageProcessing) this).br << 8));
		    ((ImageProcessing) this).b
			= ((ImageProcessing) this).rgb & 0xff;
		    if (((ImageProcessing) this).b
			> 255 - ((ImageProcessing) this).br)
			((ImageProcessing) this).b = 255;
		    else
			((ImageProcessing) this).b
			    = (((ImageProcessing) this).b
			       + ((ImageProcessing) this).br);
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= (((ImageProcessing) this).rgb & ~0xffffff
			   | ((ImageProcessing) this).r
			   | ((ImageProcessing) this).g
			   | ((ImageProcessing) this).b);
		} else {
		    ((ImageProcessing) this).br = -k;
		    ((ImageProcessing) this).r
			= ((ImageProcessing) this).rgb & 0xff0000;
		    if (((ImageProcessing) this).r
			< ((ImageProcessing) this).br << 16)
			((ImageProcessing) this).r = 0;
		    else
			((ImageProcessing) this).r
			    = (((ImageProcessing) this).r
			       - (((ImageProcessing) this).br << 16));
		    ((ImageProcessing) this).g
			= ((ImageProcessing) this).rgb & 0xff00;
		    if (((ImageProcessing) this).g
			< ((ImageProcessing) this).br << 8)
			((ImageProcessing) this).g = 0;
		    else
			((ImageProcessing) this).g
			    = (((ImageProcessing) this).g
			       - (((ImageProcessing) this).br << 8));
		    ((ImageProcessing) this).b
			= ((ImageProcessing) this).rgb & 0xff;
		    if (((ImageProcessing) this).b
			< ((ImageProcessing) this).br)
			((ImageProcessing) this).b = 0;
		    else
			((ImageProcessing) this).b
			    = (((ImageProcessing) this).b
			       - ((ImageProcessing) this).br);
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= (((ImageProcessing) this).rgb & ~0xffffff
			   | ((ImageProcessing) this).r
			   | ((ImageProcessing) this).g
			   | ((ImageProcessing) this).b);
		}
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image EdgeDetect(Image img, int Method, double value1) {
	ImageToMatrix(img);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		if (((ImageProcessing) this).i == 0
		    || (((ImageProcessing) this).i
			== ((ImageProcessing) this).w - 1)
		    || ((ImageProcessing) this).j == 0
		    || (((ImageProcessing) this).j
			== ((ImageProcessing) this).h - 1))
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= (((ImageProcessing) this).pix
			   [((((ImageProcessing) this).j
			      * ((ImageProcessing) this).w)
			     + ((ImageProcessing) this).i)]) & ~0xffffff | 0x0;
		else {
		    for (((ImageProcessing) this).c = 0;
			 ((ImageProcessing) this).c < 3;
			 ((ImageProcessing) this).c++) {
			((ImageProcessing) this).p1
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j - 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i - 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p2
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j - 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p3
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j - 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i + 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p4
			    = (((((ImageProcessing) this).pix
				 [((((ImageProcessing) this).j
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i - 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p5
			    = (((((ImageProcessing) this).pix
				 [((((ImageProcessing) this).j
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p6
			    = (((((ImageProcessing) this).pix
				 [((((ImageProcessing) this).j
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i + 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p7
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j + 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i - 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p8
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j + 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			((ImageProcessing) this).p9
			    = (((((ImageProcessing) this).pix
				 [(((((ImageProcessing) this).j + 1)
				    * ((ImageProcessing) this).w)
				   + ((ImageProcessing) this).i + 1)])
				& (((ImageProcessing) this).c1
				   [((ImageProcessing) this).c]))
			       >> (((ImageProcessing) this).c2
				   [((ImageProcessing) this).c]));
			if (Method == 1) {
			    ((ImageProcessing) this).r
				= (((ImageProcessing) this).p1
				   + ((ImageProcessing) this).p4
				   + ((ImageProcessing) this).p7
				   - ((ImageProcessing) this).p3
				   - ((ImageProcessing) this).p6
				   - ((ImageProcessing) this).p9);
			    ((ImageProcessing) this).g
				= (((ImageProcessing) this).p1
				   + ((ImageProcessing) this).p2
				   + ((ImageProcessing) this).p3
				   - ((ImageProcessing) this).p7
				   - ((ImageProcessing) this).p8
				   - ((ImageProcessing) this).p9);
			    ((ImageProcessing) this).rgbpix
				[((ImageProcessing) this).c]
				= (int) (Math.sqrt
					 ((double) ((((((ImageProcessing) this)
						       .r)
						      * ((ImageProcessing)
							 this).r)
						     + (((ImageProcessing)
							 this).g
							* ((ImageProcessing)
							   this).g))
						    / 6)));
			} else if (Method == 5) {
			    ((ImageProcessing) this).r
				= (((ImageProcessing) this).p1
				   + 2 * ((ImageProcessing) this).p4
				   + ((ImageProcessing) this).p7
				   - ((ImageProcessing) this).p3
				   - 2 * ((ImageProcessing) this).p6
				   - ((ImageProcessing) this).p9);
			    ((ImageProcessing) this).g
				= (((ImageProcessing) this).p1
				   + 2 * ((ImageProcessing) this).p2
				   + ((ImageProcessing) this).p3
				   - ((ImageProcessing) this).p7
				   - 2 * ((ImageProcessing) this).p8
				   - ((ImageProcessing) this).p9);
			    ((ImageProcessing) this).rgbpix
				[((ImageProcessing) this).c]
				= (((ImageProcessing) this).p5
				   - (int) ((double) ((((ImageProcessing) this)
						       .p5)
						      * 16)
					    * (Math.sqrt
					       (Math.sqrt
						((double) (((((ImageProcessing)
							      this).r
							     * ((ImageProcessing)
								this).r)
							    + (((ImageProcessing)
								this).g
							       * ((ImageProcessing)
								  this).g))
							   / 9))))
					    / 255.0));
			} else if (Method == 2) {
			    ((ImageProcessing) this).rgbpix
				[((ImageProcessing) this).c]
				= -(-((ImageProcessing) this).p1
				    - ((ImageProcessing) this).p2
				    - ((ImageProcessing) this).p3
				    - ((ImageProcessing) this).p4
				    + 8 * ((ImageProcessing) this).p5
				    - ((ImageProcessing) this).p6
				    - ((ImageProcessing) this).p7
				    - ((ImageProcessing) this).p8
				    - ((ImageProcessing) this).p9);
			    ((ImageProcessing) this).rgbpix
				[((ImageProcessing) this).c]
				= (((ImageProcessing) this).p5
				   - (int) (value1
					    * (double) (((ImageProcessing)
							 this)
							.rgbpix
							[((ImageProcessing)
							  this).c])));
			    if ((((ImageProcessing) this).rgbpix
				 [((ImageProcessing) this).c])
				> 255)
				((ImageProcessing) this).rgbpix
				    [((ImageProcessing) this).c]
				    = 255;
			    if ((((ImageProcessing) this).rgbpix
				 [((ImageProcessing) this).c])
				< 0)
				((ImageProcessing) this).rgbpix
				    [((ImageProcessing) this).c]
				    = 0;
			} else if (Method == 3) {
			    ((ImageProcessing) this).rgbpix
				[((ImageProcessing) this).c]
				= (-((ImageProcessing) this).p1
				   - ((ImageProcessing) this).p2
				   - ((ImageProcessing) this).p3
				   - ((ImageProcessing) this).p4
				   + 8 * ((ImageProcessing) this).p5
				   - ((ImageProcessing) this).p6
				   - ((ImageProcessing) this).p7
				   - ((ImageProcessing) this).p8
				   - ((ImageProcessing) this).p9);
			    if ((((ImageProcessing) this).rgbpix
				 [((ImageProcessing) this).c])
				> 255)
				((ImageProcessing) this).rgbpix
				    [((ImageProcessing) this).c]
				    = 255;
			    if ((((ImageProcessing) this).rgbpix
				 [((ImageProcessing) this).c])
				< 0)
				((ImageProcessing) this).rgbpix
				    [((ImageProcessing) this).c]
				    = 0;
			} else if (Method == 4) {
			    ((ImageProcessing) this).r
				= (((ImageProcessing) this).p2
				   - ((ImageProcessing) this).p4);
			    ((ImageProcessing) this).g
				= (((ImageProcessing) this).p1
				   - ((ImageProcessing) this).p5);
			    ((ImageProcessing) this).rgbpix
				[((ImageProcessing) this).c]
				= (int) (Math.sqrt
					 ((double) ((((ImageProcessing) this).r
						     * ((ImageProcessing)
							this).r)
						    + (((ImageProcessing)
							this).g
						       * ((ImageProcessing)
							  this).g))));
			} else if (Method == 6) {
			    ((ImageProcessing) this).r
				= (((ImageProcessing) this).p1
				   + 2 * ((ImageProcessing) this).p4
				   + ((ImageProcessing) this).p7
				   - ((ImageProcessing) this).p3
				   - 2 * ((ImageProcessing) this).p6
				   - ((ImageProcessing) this).p9);
			    ((ImageProcessing) this).g
				= (((ImageProcessing) this).p1
				   + 2 * ((ImageProcessing) this).p2
				   + ((ImageProcessing) this).p3
				   - ((ImageProcessing) this).p7
				   - 2 * ((ImageProcessing) this).p8
				   - ((ImageProcessing) this).p9);
			    ((ImageProcessing) this).rgbpix
				[((ImageProcessing) this).c]
				= (int) (Math.sqrt
					 ((double) ((((((ImageProcessing) this)
						       .r)
						      * ((ImageProcessing)
							 this).r)
						     + (((ImageProcessing)
							 this).g
							* ((ImageProcessing)
							   this).g))
						    / 9)));
			}
		    }
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		}
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image MotionWiener(Image image, double d, double d_49_) {
	ImageToMatrix(image);
	double d_50_ = 1.0 / Math.pow(d_49_, 10.0);
	d = (double) ((ImageProcessing) this).w / d;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).j++) {
		double d_51_
		    = (double) Math.abs(((ImageProcessing) this).i
					- ((ImageProcessing) this).w / 2);
		double d_52_ = 3.141592653589793 / d;
		double d_53_
		    = Math.abs(Math.sin(d_52_ * d_51_)) / (d_52_ * d_51_);
		if (d_51_ == 0.0)
		    d_53_ = 1.0;
		double d_54_ = d_53_ / (d_53_ * d_53_ + d_50_);
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		for (((ImageProcessing) this).c = 0;
		     ((ImageProcessing) this).c < ((ImageProcessing) this).col;
		     ((ImageProcessing) this).c
			 = ((ImageProcessing) this).c + 2) {
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_54_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_54_;
		    ((ImageProcessing) this).rgbpix[(((ImageProcessing) this).c
						     / 2)]
			= (int) ((double) ((((ImageProcessing) this).rgb
					    & (((ImageProcessing) this)
					       .tabcolor
					       [(((ImageProcessing) this).c
						 / 2)]))
					   >> 16 - (((ImageProcessing) this).c
						    * 4))
				 * d_54_);
		}
		if (((ImageProcessing) this).col == 6)
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		else
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[0] << 8
			   | ((ImageProcessing) this).rgbpix[0]);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image Median(Image image, double d) {
	ImageToMatrix(image);
	((ImageProcessing) this).dim = (int) d;
	((ImageProcessing) this).cote = ((ImageProcessing) this).dim / 2;
	int[] is = new int[100];
	int[] is_55_ = new int[100];
	int[] is_56_ = new int[100];
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rtmp = 0;
		((ImageProcessing) this).gtmp = 0;
		((ImageProcessing) this).btmp = 0;
		for (((ImageProcessing) this).l = 0;
		     ((ImageProcessing) this).l < ((ImageProcessing) this).dim;
		     ((ImageProcessing) this).l++) {
		    for (((ImageProcessing) this).m = 0;
			 (((ImageProcessing) this).m
			  < ((ImageProcessing) this).dim);
			 ((ImageProcessing) this).m++) {
			int i = (((ImageProcessing) this).i
				 + ((ImageProcessing) this).m
				 - ((ImageProcessing) this).cote);
			int i_57_ = (((ImageProcessing) this).j
				     + ((ImageProcessing) this).l
				     - ((ImageProcessing) this).cote);
			((ImageProcessing) this).k
			    = ((((ImageProcessing) this).l
				* ((ImageProcessing) this).dim)
			       + ((ImageProcessing) this).m);
			if (i < 0 || i >= ((ImageProcessing) this).w
			    || i_57_ < 0
			    || i_57_ >= ((ImageProcessing) this).h) {
			    is[((ImageProcessing) this).k] = 0;
			    is_55_[((ImageProcessing) this).k] = 0;
			    is_56_[((ImageProcessing) this).k] = 0;
			} else {
			    ((ImageProcessing) this).rgb
				= (((ImageProcessing) this).pix
				   [i_57_ * ((ImageProcessing) this).w + i]);
			    is[((ImageProcessing) this).k]
				= ((((ImageProcessing) this).rgb & 0xff0000)
				   >> 16);
			    is_55_[((ImageProcessing) this).k]
				= (((ImageProcessing) this).rgb & 0xff00) >> 8;
			    is_56_[((ImageProcessing) this).k]
				= ((ImageProcessing) this).rgb & 0xff;
			}
		    }
		}
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = ((((ImageProcessing) this).pix
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]) & ~0xffffff
		       | (returnMedian(is, (((ImageProcessing) this).dim
					    * ((ImageProcessing) this).dim))
			  << 16)
		       | returnMedian(is_55_,
				      (((ImageProcessing) this).dim
				       * ((ImageProcessing) this).dim)) << 8
		       | returnMedian(is_56_,
				      (((ImageProcessing) this).dim
				       * ((ImageProcessing) this).dim)));
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public double returnMean(int[] tableau, int size) {
	((ImageProcessing) this).z = 0.0;
	for (((ImageProcessing) this).q = 0; ((ImageProcessing) this).q < size;
	     ((ImageProcessing) this).q++)
	    ((ImageProcessing) this).z
		= (((ImageProcessing) this).z
		   + (double) tableau[((ImageProcessing) this).q]);
	return ((ImageProcessing) this).z / (double) size;
    }
    
    public Image PSF(Image img, double value1) {
	ImageToMatrix(img);
	((ImageProcessing) this).dim = (int) value1;
	((ImageProcessing) this).cote = ((ImageProcessing) this).dim / 2;
	((ImageProcessing) this).total = 0;
	double[] psftab = new double[((ImageProcessing) this).dim + 1];
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).dim;
	     ((ImageProcessing) this).i++) {
	    psftab[((ImageProcessing) this).i]
		= -0.1 + ((double) ((ImageProcessing) this).i * 0.2
			  / (double) (((ImageProcessing) this).dim - 1));
	    psftab[((ImageProcessing) this).i]
		= (Math.exp(-Math.pow(psftab[((ImageProcessing) this).i], 2.0)
			    / 0.009800000000000001)
		   / Math.sqrt(6.283185307179586));
	}
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).dim;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).dim;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).matfilt
		    [(((ImageProcessing) this).j
		      + (((ImageProcessing) this).dim
			 * ((ImageProcessing) this).i))]
		    = (int) Math.round(100.0
				       * psftab[((ImageProcessing) this).i]
				       * psftab[((ImageProcessing) this).j]);
		((ImageProcessing) this).total
		    = (((ImageProcessing) this).total
		       + (((ImageProcessing) this).matfilt
			  [(((ImageProcessing) this).j
			    + (((ImageProcessing) this).dim
			       * ((ImageProcessing) this).i))]));
	    }
	}
	LinearFilter();
	return MatrixToImage();
    }
    
    public void ImageToMatrix(Image img2) {
	((ImageProcessing) this).app.showStatus("Transforming Image");
	((ImageProcessing) this).h = img2.getHeight(this);
	((ImageProcessing) this).w = img2.getWidth(this);
	PixelGrabber es
	    = new PixelGrabber(img2, 0, 0, ((ImageProcessing) this).w,
			       ((ImageProcessing) this).h,
			       ((ImageProcessing) this).pix, 0,
			       ((ImageProcessing) this).w);
	try {
	    es.grabPixels();
	} catch (Exception ex) {
	    ((ImageProcessing) this).app.showStatus("Error: " + ex.toString());
	}
    }
    
    public Image Padding(Image img, double value1) {
	ImageToMatrix(img);
	int d = (int) value1;
	int sup = 0;
	for (((ImageProcessing) this).i = 0; ((ImageProcessing) this).i < d;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < d;
		 ((ImageProcessing) this).j++) {
		if (((ImageProcessing) this).i >= ((ImageProcessing) this).w
		    || ((ImageProcessing) this).j >= ((ImageProcessing) this).h
		    || ((ImageProcessing) this).i < sup
		    || ((ImageProcessing) this).j < sup)
		    ((ImageProcessing) this).rgb
			= ((ImageProcessing) this).rgb & ~0xffffff | 0x0;
		else
		    ((ImageProcessing) this).rgb
			= (((ImageProcessing) this).pix
			   [(((((ImageProcessing) this).j - sup)
			      * ((ImageProcessing) this).w)
			     + ((ImageProcessing) this).i - sup)]);
		((ImageProcessing) this).pix2[(((ImageProcessing) this).j * d
					       + ((ImageProcessing) this).i)]
		    = ((ImageProcessing) this).rgb;
	    }
	}
	((ImageProcessing) this).w = d;
	((ImageProcessing) this).h = d;
	return MatrixToImage();
    }
    
    public Image MotionBlur(Image image, double d) {
	ImageToMatrix(image);
	double d_58_ = (double) ((ImageProcessing) this).w / d;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).j++) {
		double d_59_
		    = (double) Math.abs(((ImageProcessing) this).i
					- ((ImageProcessing) this).w / 2);
		double d_60_ = 3.141592653589793 / d_58_;
		double d_61_
		    = Math.abs(Math.sin(d_60_ * d_59_)) / (d_60_ * d_59_);
		if (d_59_ == 0.0)
		    d_61_ = 1.0;
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		for (((ImageProcessing) this).c = 0;
		     ((ImageProcessing) this).c < ((ImageProcessing) this).col;
		     ((ImageProcessing) this).c
			 = ((ImageProcessing) this).c + 2) {
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_61_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_61_;
		    ((ImageProcessing) this).rgbpix[(((ImageProcessing) this).c
						     / 2)]
			= (int) ((double) ((((ImageProcessing) this).rgb
					    & (((ImageProcessing) this)
					       .tabcolor
					       [(((ImageProcessing) this).c
						 / 2)]))
					   >> 16 - (((ImageProcessing) this).c
						    * 4))
				 * d_61_);
		}
		if (((ImageProcessing) this).col == 6)
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		else
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[0] << 8
			   | ((ImageProcessing) this).rgbpix[0]);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image DePadding(Image img, int ww, int hh) {
	ImageToMatrix(img);
	for (((ImageProcessing) this).i = 0; ((ImageProcessing) this).i < ww;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < hh; ((ImageProcessing) this).j++)
		((ImageProcessing) this).pix2[(((ImageProcessing) this).j * ww
					       + ((ImageProcessing) this).i)]
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
	}
	((ImageProcessing) this).w = ww;
	((ImageProcessing) this).h = hh;
	return MatrixToImage();
    }
    
    public Image Kirsh(Image img) {
	int[] tk = { 5, 5, 5, -3, -3, -3, -3, -3 };
	int[] tp = new int[10];
	ImageToMatrix(img);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		if (((ImageProcessing) this).i == 0
		    || (((ImageProcessing) this).i
			== ((ImageProcessing) this).w - 1)
		    || ((ImageProcessing) this).j == 0
		    || (((ImageProcessing) this).j
			== ((ImageProcessing) this).h - 1))
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= (((ImageProcessing) this).pix
			   [((((ImageProcessing) this).j
			      * ((ImageProcessing) this).w)
			     + ((ImageProcessing) this).i)]) & ~0xffffff | 0x0;
		else {
		    for (((ImageProcessing) this).c = 0;
			 ((ImageProcessing) this).c < 3;
			 ((ImageProcessing) this).c++) {
			tp[1] = (((((ImageProcessing) this).pix
				   [(((((ImageProcessing) this).j - 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i - 1)])
				  & (((ImageProcessing) this).c1
				     [((ImageProcessing) this).c]))
				 >> (((ImageProcessing) this).c2
				     [((ImageProcessing) this).c]));
			tp[2] = (((((ImageProcessing) this).pix
				   [(((((ImageProcessing) this).j - 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i)])
				  & (((ImageProcessing) this).c1
				     [((ImageProcessing) this).c]))
				 >> (((ImageProcessing) this).c2
				     [((ImageProcessing) this).c]));
			tp[3] = (((((ImageProcessing) this).pix
				   [(((((ImageProcessing) this).j - 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i + 1)])
				  & (((ImageProcessing) this).c1
				     [((ImageProcessing) this).c]))
				 >> (((ImageProcessing) this).c2
				     [((ImageProcessing) this).c]));
			tp[8] = (((((ImageProcessing) this).pix
				   [((((ImageProcessing) this).j
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i - 1)])
				  & (((ImageProcessing) this).c1
				     [((ImageProcessing) this).c]))
				 >> (((ImageProcessing) this).c2
				     [((ImageProcessing) this).c]));
			tp[4] = (((((ImageProcessing) this).pix
				   [((((ImageProcessing) this).j
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i + 1)])
				  & (((ImageProcessing) this).c1
				     [((ImageProcessing) this).c]))
				 >> (((ImageProcessing) this).c2
				     [((ImageProcessing) this).c]));
			tp[7] = (((((ImageProcessing) this).pix
				   [(((((ImageProcessing) this).j + 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i - 1)])
				  & (((ImageProcessing) this).c1
				     [((ImageProcessing) this).c]))
				 >> (((ImageProcessing) this).c2
				     [((ImageProcessing) this).c]));
			tp[6] = (((((ImageProcessing) this).pix
				   [(((((ImageProcessing) this).j + 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i)])
				  & (((ImageProcessing) this).c1
				     [((ImageProcessing) this).c]))
				 >> (((ImageProcessing) this).c2
				     [((ImageProcessing) this).c]));
			tp[5] = (((((ImageProcessing) this).pix
				   [(((((ImageProcessing) this).j + 1)
				      * ((ImageProcessing) this).w)
				     + ((ImageProcessing) this).i + 1)])
				  & (((ImageProcessing) this).c1
				     [((ImageProcessing) this).c]))
				 >> (((ImageProcessing) this).c2
				     [((ImageProcessing) this).c]));
			((ImageProcessing) this).rgbpix
			    [((ImageProcessing) this).c]
			    = 0;
			for (((ImageProcessing) this).p = 0;
			     ((ImageProcessing) this).p < 8;
			     ((ImageProcessing) this).p++) {
			    ((ImageProcessing) this).tab2
				[((ImageProcessing) this).p]
				= 0;
			    for (((ImageProcessing) this).m = 0;
				 ((ImageProcessing) this).m < 8;
				 ((ImageProcessing) this).m++)
				((ImageProcessing) this).tab2
				    [((ImageProcessing) this).p]
				    = ((((ImageProcessing) this).tab2
					[((ImageProcessing) this).p])
				       + (tp[((ImageProcessing) this).m + 1]
					  * tk[((((ImageProcessing) this).m
						 + ((ImageProcessing) this).p)
						% 8)]));
			    ((ImageProcessing) this).tab2
				[((ImageProcessing) this).p]
				= Math.abs((((ImageProcessing) this).tab2
					    [((ImageProcessing) this).p])
					   / 30);
			    if ((((ImageProcessing) this).tab2
				 [((ImageProcessing) this).p])
				> (((ImageProcessing) this).rgbpix
				   [((ImageProcessing) this).c]))
				((ImageProcessing) this).rgbpix
				    [((ImageProcessing) this).c]
				    = (((ImageProcessing) this).tab2
				       [((ImageProcessing) this).p]);
			}
		    }
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		}
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image Zoom4(Image img) {
	ImageToMatrix(img);
	((ImageProcessing) this).w = ((ImageProcessing) this).w * 4;
	((ImageProcessing) this).h = ((ImageProcessing) this).h * 4;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++)
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = -16777216;
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i = ((ImageProcessing) this).i + 4) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j = ((ImageProcessing) this).j + 4)
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j / 4
			  * (((ImageProcessing) this).w / 4))
			 + ((ImageProcessing) this).i / 4)]);
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image LinearInterpolation(Image img) {
	int[] filt = { 1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 1, 1, 1, 1,
		       0, 0, 0, 0, 0, 0 };
	ImageToMatrix(img);
	((ImageProcessing) this).dim = 5;
	((ImageProcessing) this).cote = 2;
	((ImageProcessing) this).total = 1;
	for (((ImageProcessing) this).i = 0;
	     (((ImageProcessing) this).i
	      < ((ImageProcessing) this).dim * ((ImageProcessing) this).dim);
	     ((ImageProcessing) this).i++)
	    ((ImageProcessing) this).matfilt[((ImageProcessing) this).i]
		= filt[((ImageProcessing) this).i];
	LinearFilter();
	return MatrixToImage();
    }
    
    public Image Contrast(Image img, int k) {
	ImageToMatrix(img);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		((ImageProcessing) this).r
		    = (((ImageProcessing) this).rgb & 0xff0000) >> 16;
		((ImageProcessing) this).g
		    = (((ImageProcessing) this).rgb & 0xff00) >> 8;
		((ImageProcessing) this).b
		    = ((ImageProcessing) this).rgb & 0xff;
		if (k >= 0) {
		    if (((ImageProcessing) this).r > 128)
			((ImageProcessing) this).r
			    = (((ImageProcessing) this).r
			       + (255 - ((ImageProcessing) this).r) * k / 128);
		    else
			((ImageProcessing) this).r
			    = ((ImageProcessing) this).r * (128 - k) / 128;
		    if (((ImageProcessing) this).g > 128)
			((ImageProcessing) this).g
			    = (((ImageProcessing) this).g
			       + (255 - ((ImageProcessing) this).g) * k / 128);
		    else
			((ImageProcessing) this).g
			    = ((ImageProcessing) this).g * (128 - k) / 128;
		    if (((ImageProcessing) this).b > 128)
			((ImageProcessing) this).b
			    = (((ImageProcessing) this).b
			       + (255 - ((ImageProcessing) this).b) * k / 128);
		    else
			((ImageProcessing) this).b
			    = ((ImageProcessing) this).b * (128 - k) / 128;
		} else {
		    ((ImageProcessing) this).br = -k;
		    if (((ImageProcessing) this).r > 128)
			((ImageProcessing) this).r
			    = (((ImageProcessing) this).r
			       - ((((ImageProcessing) this).r - 128)
				  * ((ImageProcessing) this).br / 128));
		    else
			((ImageProcessing) this).r
			    = 128 - ((128 - ((ImageProcessing) this).r)
				     * (128 - ((ImageProcessing) this).br)
				     / 128);
		    if (((ImageProcessing) this).g > 128)
			((ImageProcessing) this).g
			    = (((ImageProcessing) this).g
			       - ((((ImageProcessing) this).g - 128)
				  * ((ImageProcessing) this).br / 128));
		    else
			((ImageProcessing) this).g
			    = 128 - ((128 - ((ImageProcessing) this).g)
				     * (128 - ((ImageProcessing) this).br)
				     / 128);
		    if (((ImageProcessing) this).b > 128)
			((ImageProcessing) this).b
			    = (((ImageProcessing) this).b
			       - ((((ImageProcessing) this).b - 128)
				  * ((ImageProcessing) this).br / 128));
		    else
			((ImageProcessing) this).b
			    = 128 - ((128 - ((ImageProcessing) this).b)
				     * (128 - ((ImageProcessing) this).br)
				     / 128);
		}
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = (((ImageProcessing) this).rgb & ~0xffffff
		       | ((ImageProcessing) this).r << 16
		       | ((ImageProcessing) this).g << 8
		       | ((ImageProcessing) this).b);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image GaussianBlur(Image image, double d) {
	ImageToMatrix(image);
	double d_62_ = Math.pow(d, 2.0);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).j++) {
		double d_63_
		    = (Math.pow((double) (((ImageProcessing) this).i
					  - ((ImageProcessing) this).w / 2),
				2.0)
		       + Math.pow((double) (((ImageProcessing) this).j
					    - ((ImageProcessing) this).h / 2),
				  2.0));
		double d_64_ = Math.exp(-0.5 * d_63_ / d_62_);
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		for (((ImageProcessing) this).c = 0;
		     ((ImageProcessing) this).c < ((ImageProcessing) this).col;
		     ((ImageProcessing) this).c
			 = ((ImageProcessing) this).c + 2) {
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_64_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_64_;
		    ((ImageProcessing) this).rgbpix[(((ImageProcessing) this).c
						     / 2)]
			= (int) ((double) ((((ImageProcessing) this).rgb
					    & (((ImageProcessing) this)
					       .tabcolor
					       [(((ImageProcessing) this).c
						 / 2)]))
					   >> 16 - (((ImageProcessing) this).c
						    * 4))
				 * d_64_);
		}
		if (((ImageProcessing) this).col == 6)
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		else
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[0] << 8
			   | ((ImageProcessing) this).rgbpix[0]);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image HistoEq(Image img) {
	ImageToMatrix(img);
	int[] rsomme = new int[300];
	int[] gsomme = new int[300];
	int[] bsomme = new int[300];
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		rsomme[(((ImageProcessing) this).rgb & 0xff0000) >> 16]++;
		gsomme[(((ImageProcessing) this).rgb & 0xff00) >> 8]++;
		bsomme[((ImageProcessing) this).rgb & 0xff]++;
	    }
	}
	((ImageProcessing) this).r = 0;
	((ImageProcessing) this).g = 0;
	((ImageProcessing) this).b = 0;
	for (((ImageProcessing) this).i = 0; ((ImageProcessing) this).i < 256;
	     ((ImageProcessing) this).i++) {
	    ((ImageProcessing) this).r
		= (((ImageProcessing) this).r
		   + rsomme[((ImageProcessing) this).i]);
	    rsomme[((ImageProcessing) this).i] = ((ImageProcessing) this).r;
	    ((ImageProcessing) this).g
		= (((ImageProcessing) this).g
		   + gsomme[((ImageProcessing) this).i]);
	    gsomme[((ImageProcessing) this).i] = ((ImageProcessing) this).g;
	    ((ImageProcessing) this).b
		= (((ImageProcessing) this).b
		   + bsomme[((ImageProcessing) this).i]);
	    bsomme[((ImageProcessing) this).i] = ((ImageProcessing) this).b;
	}
	for (((ImageProcessing) this).i = 0; ((ImageProcessing) this).i < 256;
	     ((ImageProcessing) this).i++) {
	    rsomme[((ImageProcessing) this).i]
		= rsomme[((ImageProcessing) this).i] * 255 / rsomme[255];
	    gsomme[((ImageProcessing) this).i]
		= gsomme[((ImageProcessing) this).i] * 255 / gsomme[255];
	    bsomme[((ImageProcessing) this).i]
		= bsomme[((ImageProcessing) this).i] * 255 / bsomme[255];
	}
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		((ImageProcessing) this).r
		    = rsomme[(((ImageProcessing) this).rgb & 0xff0000) >> 16];
		((ImageProcessing) this).g
		    = gsomme[(((ImageProcessing) this).rgb & 0xff00) >> 8];
		((ImageProcessing) this).b
		    = bsomme[((ImageProcessing) this).rgb & 0xff];
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = ((((ImageProcessing) this).pix
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]) & ~0xffffff
		       | ((ImageProcessing) this).r << 16
		       | ((ImageProcessing) this).g << 8
		       | ((ImageProcessing) this).b);
	    }
	}
	return MatrixToImage();
    }
    
    public Image IBD(Image img, double value1, double psf) {
	int it = (int) value1;
	int data1 = 0;
	int data2 = 132099;
	int data3 = 264197;
	int data4 = 396295;
	double alpha = 0.5;
	int psfsize = (int) psf;
	int ax = 2;
	int ay = 2;
	int bx = ((ImageProcessing) this).w - 1;
	int by = ((ImageProcessing) this).w - 1;
	((ImageProcessing) this).dataset = data1;
	FFT(img, 1, 0, false, "");
	for (((ImageProcessing) this).i = 1;
	     ((ImageProcessing) this).i <= ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 1;
		 ((ImageProcessing) this).j <= ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		int ii = (((ImageProcessing) this).col
			  * ((((ImageProcessing) this).j
			      * ((ImageProcessing) this).w)
			     + ((ImageProcessing) this).i));
		if (((ImageProcessing) this).i >= ax
		    && ((ImageProcessing) this).i <= bx
		    && ((ImageProcessing) this).j >= ay
		    && ((ImageProcessing) this).j <= by) {
		    ((ImageProcessing) this).tab[ii + data2] = 1.0;
		    ((ImageProcessing) this).tab[ii + 1 + data2] = 0.0;
		} else {
		    ((ImageProcessing) this).tab[ii + data2] = 0.0;
		    ((ImageProcessing) this).tab[ii + 1 + data2] = 0.0;
		}
	    }
	}
	for (((ImageProcessing) this).i = 1;
	     ((ImageProcessing) this).i <= ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 1;
		 ((ImageProcessing) this).j <= ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		int ii = (((ImageProcessing) this).col
			  * ((((ImageProcessing) this).j
			      * ((ImageProcessing) this).w)
			     + ((ImageProcessing) this).i));
		if (((ImageProcessing) this).i == psfsize / 2 + 1
		    && ((ImageProcessing) this).j == psfsize / 2 + 1) {
		    ((ImageProcessing) this).tab[ii + data3] = 1.0;
		    ((ImageProcessing) this).tab[ii + 1 + data3] = 0.0;
		} else {
		    ((ImageProcessing) this).tab[ii + data3] = 0.0;
		    ((ImageProcessing) this).tab[ii + 1 + data3] = 0.0;
		}
	    }
	}
	for (int nb = 0; nb < it; nb++) {
	    ((ImageProcessing) this).dataset = data2;
	    FFT(img, 1, 1, false, "Iteration: " + (nb + 1) + " ; ");
	    ((ImageProcessing) this).dataset = data3;
	    FFT(img, 1, 1, false, "Iteration: " + (nb + 1) + " ; ");
	    for (((ImageProcessing) this).i = 1;
		 ((ImageProcessing) this).i <= ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 1;
		     ((ImageProcessing) this).j <= ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int ii = (((ImageProcessing) this).col
			      * ((((ImageProcessing) this).j
				  * ((ImageProcessing) this).w)
				 + ((ImageProcessing) this).i));
		    double coef
			= ((((ImageProcessing) this).tab[ii + data2]
			    * ((ImageProcessing) this).tab[ii + data2])
			   + (((ImageProcessing) this).tab[ii + 1 + data2]
			      * ((ImageProcessing) this).tab[ii + 1 + data2])
			   + (alpha
			      / ((((ImageProcessing) this).tab[ii + data3]
				  * ((ImageProcessing) this).tab[ii + data3])
				 + ((((ImageProcessing) this).tab
				     [ii + 1 + data3])
				    * (((ImageProcessing) this).tab
				       [ii + 1 + data3])))));
		    ((ImageProcessing) this).tab[ii + data3]
			= (((((ImageProcessing) this).tab[ii]
			     * ((ImageProcessing) this).tab[ii + data2])
			    + (((ImageProcessing) this).tab[ii + 1]
			       * ((ImageProcessing) this).tab[ii + 1 + data2]))
			   / coef);
		    ((ImageProcessing) this).tab[ii + 1 + data3]
			= (((-((ImageProcessing) this).tab[ii]
			     * ((ImageProcessing) this).tab[ii + 1 + data2])
			    + (((ImageProcessing) this).tab[ii + 1]
			       * ((ImageProcessing) this).tab[ii + data2]))
			   / coef);
		}
	    }
	    FFT(img, -1, 1, false, "Iteration: " + (nb + 1) + " ; ");
	    for (((ImageProcessing) this).i = 1;
		 ((ImageProcessing) this).i <= ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 1;
		     ((ImageProcessing) this).j <= ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int ii = (((ImageProcessing) this).col
			      * ((((ImageProcessing) this).j
				  * ((ImageProcessing) this).w)
				 + ((ImageProcessing) this).i));
		    if (((ImageProcessing) this).i <= psfsize
			&& ((ImageProcessing) this).j <= psfsize) {
			((ImageProcessing) this).tab[ii + data3]
			    = Math.sqrt(((((ImageProcessing) this).tab
					  [ii + data3])
					 * (((ImageProcessing) this).tab
					    [ii + data3]))
					+ ((((ImageProcessing) this).tab
					    [ii + 1 + data3])
					   * (((ImageProcessing) this).tab
					      [ii + 1 + data3])));
			((ImageProcessing) this).tab[ii + 1 + data3] = 0.0;
		    } else {
			((ImageProcessing) this).tab[ii + data3] = 0.0;
			((ImageProcessing) this).tab[ii + 1 + data3] = 0.0;
		    }
		    ((ImageProcessing) this).tab[ii + data4]
			= ((ImageProcessing) this).tab[ii + data3];
		    ((ImageProcessing) this).tab[ii + 1 + data4] = 0.0;
		}
	    }
	    FFT(img, 1, 1, false, "Iteration: " + (nb + 1) + " ; ");
	    for (((ImageProcessing) this).i = 1;
		 ((ImageProcessing) this).i <= ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 1;
		     ((ImageProcessing) this).j <= ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int ii = (((ImageProcessing) this).col
			      * ((((ImageProcessing) this).j
				  * ((ImageProcessing) this).w)
				 + ((ImageProcessing) this).i));
		    double coef
			= ((((ImageProcessing) this).tab[ii + data3]
			    * ((ImageProcessing) this).tab[ii + data3])
			   + (((ImageProcessing) this).tab[ii + 1 + data3]
			      * ((ImageProcessing) this).tab[ii + 1 + data3])
			   + (alpha
			      / ((((ImageProcessing) this).tab[ii + data2]
				  * ((ImageProcessing) this).tab[ii + data2])
				 + ((((ImageProcessing) this).tab
				     [ii + 1 + data2])
				    * (((ImageProcessing) this).tab
				       [ii + 1 + data2])))));
		    ((ImageProcessing) this).tab[ii + data2]
			= (((((ImageProcessing) this).tab[ii]
			     * ((ImageProcessing) this).tab[ii + data3])
			    + (((ImageProcessing) this).tab[ii + 1]
			       * ((ImageProcessing) this).tab[ii + 1 + data3]))
			   / coef);
		    ((ImageProcessing) this).tab[ii + 1 + data2]
			= (((-((ImageProcessing) this).tab[ii]
			     * ((ImageProcessing) this).tab[ii + 1 + data3])
			    + (((ImageProcessing) this).tab[ii + 1]
			       * ((ImageProcessing) this).tab[ii + data3]))
			   / coef);
		}
	    }
	    ((ImageProcessing) this).dataset = data2;
	    FFT(img, -1, 1, false, "Iteration: " + (nb + 1) + " ; ");
	    for (((ImageProcessing) this).i = 1;
		 ((ImageProcessing) this).i <= ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 1;
		     ((ImageProcessing) this).j <= ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    int ii = (((ImageProcessing) this).col
			      * ((((ImageProcessing) this).j
				  * ((ImageProcessing) this).w)
				 + ((ImageProcessing) this).i));
		    ((ImageProcessing) this).tab[ii + data2]
			= Math.sqrt((((ImageProcessing) this).tab[ii + data2]
				     * (((ImageProcessing) this).tab
					[ii + data2]))
				    + ((((ImageProcessing) this).tab
					[ii + 1 + data2])
				       * (((ImageProcessing) this).tab
					  [ii + 1 + data2])));
		    ((ImageProcessing) this).tab[ii + 1 + data2] = 0.0;
		    if (((ImageProcessing) this).i < ax
			|| ((ImageProcessing) this).i > bx
			|| ((ImageProcessing) this).j < ay
			|| ((ImageProcessing) this).j > by)
			((ImageProcessing) this).tab[ii + data2] = 0.0;
		    ((ImageProcessing) this).tab[ii + data3]
			= ((ImageProcessing) this).tab[ii + data4];
		    ((ImageProcessing) this).tab[ii + 1 + data3] = 0.0;
		}
	    }
	    for (((ImageProcessing) this).i = 1;
		 ((ImageProcessing) this).i <= ((ImageProcessing) this).w;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 1;
		     ((ImageProcessing) this).j <= ((ImageProcessing) this).h;
		     ((ImageProcessing) this).j++) {
		    if (((ImageProcessing) this).i < ax
			|| ((ImageProcessing) this).i > bx
			|| ((ImageProcessing) this).j < ay
			|| ((ImageProcessing) this).j > by)
			((ImageProcessing) this).pix2
			    [(((((ImageProcessing) this).j - 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i - 1)]
			    = -16777216;
		}
	    }
	    int modd;
	    if (it < 10)
		modd = 2;
	    else
		modd = it / 5;
	    if (nb < it - 1 && nb % modd == 0)
		((ImageProcessing) this).app.Addimg(MatrixToImage());
	}
	return MatrixToImage();
    }
    
    public Image Kuwahara(Image img, double value1) {
	ImageToMatrix(img);
	((ImageProcessing) this).dim = (int) value1;
	((ImageProcessing) this).cote = ((ImageProcessing) this).dim / 2;
	int[] matr = new int[100];
	int[] matg = new int[100];
	int[] matb = new int[100];
	double[] tabku = new double[100];
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		for (int py = 0; py < ((ImageProcessing) this).dim;
		     py += ((ImageProcessing) this).cote) {
		    for (int px = 0; px < ((ImageProcessing) this).dim;
			 px += ((ImageProcessing) this).cote) {
			((ImageProcessing) this).k = 0;
			for (((ImageProcessing) this).l = py;
			     (((ImageProcessing) this).l
			      <= py + ((ImageProcessing) this).cote);
			     ((ImageProcessing) this).l++) {
			    for (((ImageProcessing) this).m = px;
				 (((ImageProcessing) this).m
				  <= px + ((ImageProcessing) this).cote);
				 ((ImageProcessing) this).m++) {
				int xf = (((ImageProcessing) this).i
					  + ((ImageProcessing) this).m
					  - ((ImageProcessing) this).cote);
				int yf = (((ImageProcessing) this).j
					  + ((ImageProcessing) this).l
					  - ((ImageProcessing) this).cote);
				if (xf < 0 || xf >= ((ImageProcessing) this).w
				    || yf < 0
				    || yf >= ((ImageProcessing) this).h) {
				    matr[((ImageProcessing) this).k] = 0;
				    matg[((ImageProcessing) this).k] = 0;
				    matb[((ImageProcessing) this).k] = 0;
				} else {
				    ((ImageProcessing) this).rgb
					= (((ImageProcessing) this).pix
					   [(yf * ((ImageProcessing) this).w
					     + xf)]);
				    matr[((ImageProcessing) this).k]
					= (((ImageProcessing) this).rgb
					   & 0xff0000) >> 16;
				    matg[((ImageProcessing) this).k]
					= (((ImageProcessing) this).rgb
					   & 0xff00) >> 8;
				    matb[((ImageProcessing) this).k]
					= ((ImageProcessing) this).rgb & 0xff;
				}
				((ImageProcessing) this).k++;
			    }
			}
			tabku[(2 * py / ((ImageProcessing) this).cote
			       + px / ((ImageProcessing) this).cote)]
			    = (returnVariance
			       (matr,
				(int) Math.pow((double) (((ImageProcessing)
							  this).cote
							 + 1),
					       2.0)));
			tabku[(10 + 2 * py / ((ImageProcessing) this).cote
			       + px / ((ImageProcessing) this).cote)]
			    = (returnVariance
			       (matg,
				(int) Math.pow((double) (((ImageProcessing)
							  this).cote
							 + 1),
					       2.0)));
			tabku[(20 + 2 * py / ((ImageProcessing) this).cote
			       + px / ((ImageProcessing) this).cote)]
			    = (returnVariance
			       (matb,
				(int) Math.pow((double) (((ImageProcessing)
							  this).cote
							 + 1),
					       2.0)));
			tabku[(30 + 2 * py / ((ImageProcessing) this).cote
			       + px / ((ImageProcessing) this).cote)]
			    = (returnMean
			       (matr,
				(int) Math.pow((double) (((ImageProcessing)
							  this).cote
							 + 1),
					       2.0)));
			tabku[(40 + 2 * py / ((ImageProcessing) this).cote
			       + px / ((ImageProcessing) this).cote)]
			    = (returnMean
			       (matg,
				(int) Math.pow((double) (((ImageProcessing)
							  this).cote
							 + 1),
					       2.0)));
			tabku[(50 + 2 * py / ((ImageProcessing) this).cote
			       + px / ((ImageProcessing) this).cote)]
			    = (returnMean
			       (matb,
				(int) Math.pow((double) (((ImageProcessing)
							  this).cote
							 + 1),
					       2.0)));
		    }
		}
		double rrmax = 100000.0;
		double ggmax = 100000.0;
		double bbmax = 100000.0;
		for (((ImageProcessing) this).l = 0;
		     ((ImageProcessing) this).l < 4;
		     ((ImageProcessing) this).l++) {
		    if (tabku[((ImageProcessing) this).l] < rrmax) {
			rrmax = tabku[((ImageProcessing) this).l];
			((ImageProcessing) this).rtmp
			    = ((ImageProcessing) this).l;
		    }
		    if (tabku[10 + ((ImageProcessing) this).l] < ggmax) {
			ggmax = tabku[10 + ((ImageProcessing) this).l];
			((ImageProcessing) this).gtmp
			    = ((ImageProcessing) this).l;
		    }
		    if (tabku[20 + ((ImageProcessing) this).l] < bbmax) {
			bbmax = tabku[20 + ((ImageProcessing) this).l];
			((ImageProcessing) this).btmp
			    = ((ImageProcessing) this).l;
		    }
		}
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = ((((ImageProcessing) this).pix
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]) & ~0xffffff
		       | (int) tabku[30 + ((ImageProcessing) this).rtmp] << 16
		       | (int) tabku[40 + ((ImageProcessing) this).gtmp] << 8
		       | (int) tabku[50 + ((ImageProcessing) this).btmp]);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public int returnMedian(int[] tableau, int size) {
	((ImageProcessing) this).tab2[0] = tableau[0];
	for (((ImageProcessing) this).q = 1; ((ImageProcessing) this).q < size;
	     ((ImageProcessing) this).q++)
	    ((ImageProcessing) this).tab2[((ImageProcessing) this).q] = 1000;
	for (((ImageProcessing) this).q = 1; ((ImageProcessing) this).q < size;
	     ((ImageProcessing) this).q++) {
	    ((ImageProcessing) this).r = -1;
	    do
		((ImageProcessing) this).r++;
	    while (tableau[((ImageProcessing) this).q]
		   >= (((ImageProcessing) this).tab2
		       [((ImageProcessing) this).r]));
	    if (((ImageProcessing) this).r < ((ImageProcessing) this).q) {
		for (((ImageProcessing) this).p = ((ImageProcessing) this).r;
		     ((ImageProcessing) this).p < ((ImageProcessing) this).q;
		     ((ImageProcessing) this).p++)
		    ((ImageProcessing) this).tab2[(((ImageProcessing) this).p
						   + 1)]
			= (((ImageProcessing) this).tab2
			   [((ImageProcessing) this).p]);
	    }
	    ((ImageProcessing) this).tab2[((ImageProcessing) this).r]
		= tableau[((ImageProcessing) this).q];
	}
	return ((ImageProcessing) this).tab2[size / 2];
    }
    
    public Image FFT(Image image, int i, int i_65_, boolean bool,
		     String string) {
	if (i_65_ == 0)
	    ImageToMatrix(image);
	int i_66_ = ((ImageProcessing) this).w;
	int i_67_ = (int) Math.round(Math.log((double) i_66_) / Math.log(2.0));
	double[] ds = { 1.0, 0.0 };
	double[] ds_68_ = { 1.0, 0.0 };
	double[] ds_69_ = { 1.0, 0.0 };
	double[] ds_70_ = new double[i_66_ + 1];
	double[] ds_71_ = new double[i_66_ + 1];
	if (i == 1 && i_65_ == 0) {
	    if (isGrayscale())
		((ImageProcessing) this).col = 2;
	    else
		((ImageProcessing) this).col = 6;
	}
	if (!isFFT(((ImageProcessing) this).w, ((ImageProcessing) this).h))
	    return image;
	initcalc(i_66_);
	for (int i_72_ = 0; i_72_ < ((ImageProcessing) this).col; i_72_ += 2) {
	    if (i == 1) {
		for (((ImageProcessing) this).i = 1;
		     ((ImageProcessing) this).i <= i_66_;
		     ((ImageProcessing) this).i++) {
		    for (((ImageProcessing) this).k = 0;
			 ((ImageProcessing) this).k < i_66_;
			 ((ImageProcessing) this).k++) {
			int i_73_
			    = ((((ImageProcessing) this).col
				* ((((ImageProcessing) this).k + 1) * i_66_
				   + ((ImageProcessing) this).i))
			       + i_72_ + ((ImageProcessing) this).dataset);
			if (i_65_ == 0) {
			    ((ImageProcessing) this).tab[i_73_]
				= (double) (((((ImageProcessing) this).pix
					      [(((((ImageProcessing) this).rng1
						  [(((ImageProcessing) this).k
						    + 1)])
						 * ((ImageProcessing) this).w)
						+ ((ImageProcessing) this).i
						- 1)])
					     & (((ImageProcessing) this)
						.tabcolor[i_72_ / 2]))
					    >> 16 - i_72_ * 4);
			    ((ImageProcessing) this).tab[i_73_]
				= ((ImageProcessing) this).tab[i_73_] / 255.0;
			    ((ImageProcessing) this).tab[i_73_ + 1] = 0.0;
			} else {
			    ds_70_[((ImageProcessing) this).k]
				= (((ImageProcessing) this).tab
				   [((((ImageProcessing) this).col
				      * (((((ImageProcessing) this).rng1
					   [((ImageProcessing) this).k + 1])
					  + 1) * i_66_
					 + ((ImageProcessing) this).i))
				     + i_72_
				     + ((ImageProcessing) this).dataset)]);
			    ds_71_[((ImageProcessing) this).k]
				= (((ImageProcessing) this).tab
				   [((((ImageProcessing) this).col
				      * (((((ImageProcessing) this).rng1
					   [((ImageProcessing) this).k + 1])
					  + 1) * i_66_
					 + ((ImageProcessing) this).i))
				     + i_72_ + ((ImageProcessing) this).dataset
				     + 1)]);
			}
		    }
		    if (i_65_ != 0) {
			for (((ImageProcessing) this).k = 0;
			     ((ImageProcessing) this).k < i_66_;
			     ((ImageProcessing) this).k++) {
			    int i_74_
				= ((((ImageProcessing) this).col
				    * ((((ImageProcessing) this).k + 1) * i_66_
				       + ((ImageProcessing) this).i))
				   + i_72_ + ((ImageProcessing) this).dataset);
			    ((ImageProcessing) this).tab[i_74_]
				= ds_70_[((ImageProcessing) this).k];
			    ((ImageProcessing) this).tab[i_74_ + 1]
				= ds_71_[((ImageProcessing) this).k];
			}
		    }
		}
	    } else {
		for (((ImageProcessing) this).i = 0;
		     ((ImageProcessing) this).i < i_66_;
		     ((ImageProcessing) this).i++) {
		    for (((ImageProcessing) this).k = 1;
			 ((ImageProcessing) this).k <= i_66_;
			 ((ImageProcessing) this).k++) {
			int i_75_
			    = ((((ImageProcessing) this).col
				* (((((ImageProcessing) this).rng1
				     [((ImageProcessing) this).k])
				    + 1) * i_66_
				   + ((ImageProcessing) this).i + 1))
			       + i_72_ + ((ImageProcessing) this).dataset);
			ds_70_[((ImageProcessing) this).k]
			    = ((ImageProcessing) this).tab[i_75_];
			ds_71_[((ImageProcessing) this).k]
			    = ((ImageProcessing) this).tab[i_75_ + 1];
		    }
		    for (((ImageProcessing) this).k = 1;
			 ((ImageProcessing) this).k <= i_66_;
			 ((ImageProcessing) this).k++) {
			int i_76_
			    = ((((ImageProcessing) this).col
				* (((ImageProcessing) this).k * i_66_
				   + ((ImageProcessing) this).i + 1))
			       + i_72_ + ((ImageProcessing) this).dataset);
			((ImageProcessing) this).tab[i_76_]
			    = ds_70_[((ImageProcessing) this).k];
			((ImageProcessing) this).tab[i_76_ + 1]
			    = ds_71_[((ImageProcessing) this).k];
		    }
		}
	    }
	    ((ImageProcessing) this).app
		.showStatus(string + "Performing FFT Columns...");
	    for (int i_77_ = 1; i_77_ <= i_67_; i_77_++) {
		int i_78_ = (int) Math.round(Math.pow(2.0, (double) i_77_));
		int i_79_ = (int) Math.round((double) (i_78_ / 2));
		ds[0] = 1.0;
		ds[1] = 0.0;
		ds_68_[0] = Math.cos((double) -i * 3.141592653589793
				     / (double) i_79_);
		ds_68_[1] = Math.sin((double) -i * 3.141592653589793
				     / (double) i_79_);
		for (((ImageProcessing) this).j = 1;
		     ((ImageProcessing) this).j <= i_79_;
		     ((ImageProcessing) this).j++) {
		    for (((ImageProcessing) this).i
			     = ((ImageProcessing) this).j;
			 ((ImageProcessing) this).i <= i_66_;
			 ((ImageProcessing) this).i
			     = ((ImageProcessing) this).i + i_78_) {
			int i_80_ = ((ImageProcessing) this).i + i_79_;
			int i_81_ = ((ImageProcessing) this).i;
			for (((ImageProcessing) this).l = 1;
			     ((ImageProcessing) this).l <= i_66_;
			     ((ImageProcessing) this).l++) {
			    int i_82_
				= ((((ImageProcessing) this).col
				    * (i_80_ * i_66_
				       + ((ImageProcessing) this).l))
				   + i_72_ + ((ImageProcessing) this).dataset);
			    int i_83_
				= ((((ImageProcessing) this).col
				    * (i_81_ * i_66_
				       + ((ImageProcessing) this).l))
				   + i_72_ + ((ImageProcessing) this).dataset);
			    ds_69_[0]
				= (ds[0] * ((ImageProcessing) this).tab[i_82_]
				   - ds[1] * (((ImageProcessing) this).tab
					      [i_82_ + 1]));
			    ds_69_[1] = (ds[0] * (((ImageProcessing) this).tab
						  [i_82_ + 1])
					 + ds[1] * (((ImageProcessing) this)
						    .tab[i_82_]));
			    ((ImageProcessing) this).tab[i_82_]
				= (((ImageProcessing) this).tab[i_83_]
				   - ds_69_[0]);
			    ((ImageProcessing) this).tab[i_82_ + 1]
				= (((ImageProcessing) this).tab[i_83_ + 1]
				   - ds_69_[1]);
			    ((ImageProcessing) this).tab[i_83_]
				= (((ImageProcessing) this).tab[i_83_]
				   + ds_69_[0]);
			    ((ImageProcessing) this).tab[i_83_ + 1]
				= (((ImageProcessing) this).tab[i_83_ + 1]
				   + ds_69_[1]);
			}
		    }
		    ds_69_[0] = ds[0] * ds_68_[0] - ds[1] * ds_68_[1];
		    ds_69_[1] = ds[0] * ds_68_[1] + ds[1] * ds_68_[0];
		    ds[0] = ds_69_[0];
		    ds[1] = ds_69_[1];
		}
	    }
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < i_66_;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).k = 1;
		     ((ImageProcessing) this).k <= i_66_;
		     ((ImageProcessing) this).k++) {
		    int i_84_ = ((((ImageProcessing) this).col
				  * ((((ImageProcessing) this).i + 1) * i_66_
				     + (((ImageProcessing) this).rng1
					[((ImageProcessing) this).k])
				     + 1))
				 + i_72_ + ((ImageProcessing) this).dataset);
		    ds_70_[((ImageProcessing) this).k]
			= ((ImageProcessing) this).tab[i_84_];
		    ds_71_[((ImageProcessing) this).k]
			= ((ImageProcessing) this).tab[i_84_ + 1];
		}
		for (((ImageProcessing) this).k = 1;
		     ((ImageProcessing) this).k <= i_66_;
		     ((ImageProcessing) this).k++) {
		    int i_85_ = ((((ImageProcessing) this).col
				  * ((((ImageProcessing) this).i + 1) * i_66_
				     + ((ImageProcessing) this).k))
				 + i_72_ + ((ImageProcessing) this).dataset);
		    ((ImageProcessing) this).tab[i_85_]
			= ds_70_[((ImageProcessing) this).k];
		    ((ImageProcessing) this).tab[i_85_ + 1]
			= ds_71_[((ImageProcessing) this).k];
		}
	    }
	    ((ImageProcessing) this).app
		.showStatus(string + "Performing FFT Rows...");
	    for (int i_86_ = 1; i_86_ <= i_67_; i_86_++) {
		int i_87_ = (int) Math.pow(2.0, (double) i_86_);
		int i_88_ = i_87_ / 2;
		ds[0] = 1.0;
		ds[1] = 0.0;
		ds_68_[0] = Math.cos((double) -i * 3.141592653589793
				     / (double) i_88_);
		ds_68_[1] = Math.sin((double) -i * 3.141592653589793
				     / (double) i_88_);
		for (((ImageProcessing) this).j = 1;
		     ((ImageProcessing) this).j <= i_88_;
		     ((ImageProcessing) this).j++) {
		    for (((ImageProcessing) this).i
			     = ((ImageProcessing) this).j;
			 ((ImageProcessing) this).i <= i_66_;
			 ((ImageProcessing) this).i
			     = ((ImageProcessing) this).i + i_87_) {
			int i_89_ = ((ImageProcessing) this).i + i_88_;
			int i_90_ = ((ImageProcessing) this).i;
			for (((ImageProcessing) this).l = 1;
			     ((ImageProcessing) this).l <= i_66_;
			     ((ImageProcessing) this).l++) {
			    int i_91_
				= ((((ImageProcessing) this).col
				    * (((ImageProcessing) this).l * i_66_
				       + i_89_))
				   + i_72_ + ((ImageProcessing) this).dataset);
			    int i_92_
				= ((((ImageProcessing) this).col
				    * (((ImageProcessing) this).l * i_66_
				       + i_90_))
				   + i_72_ + ((ImageProcessing) this).dataset);
			    ds_69_[0]
				= (ds[0] * ((ImageProcessing) this).tab[i_91_]
				   - ds[1] * (((ImageProcessing) this).tab
					      [i_91_ + 1]));
			    ds_69_[1] = (ds[0] * (((ImageProcessing) this).tab
						  [i_91_ + 1])
					 + ds[1] * (((ImageProcessing) this)
						    .tab[i_91_]));
			    ((ImageProcessing) this).tab[i_91_]
				= (((ImageProcessing) this).tab[i_92_]
				   - ds_69_[0]);
			    ((ImageProcessing) this).tab[i_91_ + 1]
				= (((ImageProcessing) this).tab[i_92_ + 1]
				   - ds_69_[1]);
			    ((ImageProcessing) this).tab[i_92_]
				= (((ImageProcessing) this).tab[i_92_]
				   + ds_69_[0]);
			    ((ImageProcessing) this).tab[i_92_ + 1]
				= (((ImageProcessing) this).tab[i_92_ + 1]
				   + ds_69_[1]);
			}
		    }
		    ds_69_[0] = ds[0] * ds_68_[0] - ds[1] * ds_68_[1];
		    ds_69_[1] = ds[0] * ds_68_[1] + ds[1] * ds_68_[0];
		    ds[0] = ds_69_[0];
		    ds[1] = ds_69_[1];
		}
	    }
	    ((ImageProcessing) this).mx[i_72_] = 0.0;
	    if (i == 1 && bool) {
		((ImageProcessing) this).app
		    .showStatus(string + "Performing Swap...");
		for (((ImageProcessing) this).i = 0;
		     ((ImageProcessing) this).i < i_66_;
		     ((ImageProcessing) this).i++) {
		    for (((ImageProcessing) this).j = 0;
			 ((ImageProcessing) this).j < i_66_ / 2;
			 ((ImageProcessing) this).j++) {
			int i_93_
			    = ((((ImageProcessing) this).col
				* ((((ImageProcessing) this).j + 1) * i_66_
				   + ((ImageProcessing) this).i + 1))
			       + i_72_ + ((ImageProcessing) this).dataset);
			int i_94_
			    = ((((ImageProcessing) this).col
				* ((((ImageProcessing) this).j + 1
				    + i_66_ / 2) * i_66_
				   + ((((ImageProcessing) this).i + i_66_ / 2)
				      % i_66_)
				   + 1))
			       + i_72_ + ((ImageProcessing) this).dataset);
			ds[0] = ((ImageProcessing) this).tab[i_93_];
			ds[1] = ((ImageProcessing) this).tab[i_93_ + 1];
			((ImageProcessing) this).tab[i_93_]
			    = ((ImageProcessing) this).tab[i_94_];
			((ImageProcessing) this).tab[i_93_ + 1]
			    = ((ImageProcessing) this).tab[i_94_ + 1];
			((ImageProcessing) this).tab[i_94_] = ds[0];
			((ImageProcessing) this).tab[i_94_ + 1] = ds[1];
		    }
		}
	    }
	    ((ImageProcessing) this).app
		.showStatus(string + "Performing Rescaling Grayscale...");
	    if (i == 1) {
		for (((ImageProcessing) this).i = 0;
		     ((ImageProcessing) this).i < i_66_;
		     ((ImageProcessing) this).i++) {
		    for (((ImageProcessing) this).j = 0;
			 ((ImageProcessing) this).j < i_66_;
			 ((ImageProcessing) this).j++) {
			int i_95_
			    = ((((ImageProcessing) this).col
				* ((((ImageProcessing) this).j + 1) * i_66_
				   + ((ImageProcessing) this).i + 1))
			       + i_72_ + ((ImageProcessing) this).dataset);
			((ImageProcessing) this).val
			    = Math.sqrt((((ImageProcessing) this).tab[i_95_]
					 * ((ImageProcessing) this).tab[i_95_])
					+ ((((ImageProcessing) this).tab
					    [i_95_ + 1])
					   * (((ImageProcessing) this).tab
					      [i_95_ + 1])));
			((ImageProcessing) this).val
			    = Math.log(((ImageProcessing) this).val + 1.0);
			if (((ImageProcessing) this).val
			    > ((ImageProcessing) this).mx[i_72_])
			    ((ImageProcessing) this).mx[i_72_]
				= ((ImageProcessing) this).val;
		    }
		}
	    } else {
		((ImageProcessing) this).cmax[i_72_] = 0.0;
		for (((ImageProcessing) this).i = 0;
		     ((ImageProcessing) this).i < i_66_;
		     ((ImageProcessing) this).i++) {
		    for (((ImageProcessing) this).j = 0;
			 ((ImageProcessing) this).j < i_66_;
			 ((ImageProcessing) this).j++) {
			int i_96_
			    = ((((ImageProcessing) this).col
				* ((((ImageProcessing) this).j + 1) * i_66_
				   + ((ImageProcessing) this).i + 1))
			       + i_72_ + ((ImageProcessing) this).dataset);
			((ImageProcessing) this).tab[i_96_]
			    = (((ImageProcessing) this).tab[i_96_]
			       / (double) (i_66_ * i_66_));
			((ImageProcessing) this).tab[i_96_ + 1]
			    = (((ImageProcessing) this).tab[i_96_ + 1]
			       / (double) (i_66_ * i_66_));
			((ImageProcessing) this).val
			    = Math.sqrt((((ImageProcessing) this).tab[i_96_]
					 * ((ImageProcessing) this).tab[i_96_])
					+ ((((ImageProcessing) this).tab
					    [i_96_ + 1])
					   * (((ImageProcessing) this).tab
					      [i_96_ + 1])));
			if (((ImageProcessing) this).val
			    > ((ImageProcessing) this).cmax[i_72_])
			    ((ImageProcessing) this).cmax[i_72_]
				= ((ImageProcessing) this).val;
		    }
		}
	    }
	}
	if (i == 1) {
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < i_66_;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < i_66_;
		     ((ImageProcessing) this).j++) {
		    for (int i_97_ = 0; i_97_ < ((ImageProcessing) this).col;
			 i_97_ += 2) {
			int i_98_
			    = ((((ImageProcessing) this).col
				* ((((ImageProcessing) this).j + 1) * i_66_
				   + ((ImageProcessing) this).i + 1))
			       + i_97_ + ((ImageProcessing) this).dataset);
			((ImageProcessing) this).val
			    = Math.sqrt((((ImageProcessing) this).tab[i_98_]
					 * ((ImageProcessing) this).tab[i_98_])
					+ ((((ImageProcessing) this).tab
					    [i_98_ + 1])
					   * (((ImageProcessing) this).tab
					      [i_98_ + 1])));
			((ImageProcessing) this).val
			    = Math.log(((ImageProcessing) this).val + 1.0);
			((ImageProcessing) this).rgbpix[i_97_ / 2]
			    = (int) Math.round(255.0
					       * ((ImageProcessing) this).val
					       / (((ImageProcessing) this).mx
						  [i_97_]));
		    }
		    if (((ImageProcessing) this).col == 6)
			((ImageProcessing) this).pix2
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]
			    = ((((ImageProcessing) this).pix
				[((((ImageProcessing) this).j
				   * ((ImageProcessing) this).w)
				  + ((ImageProcessing) this).i)]) & ~0xffffff
			       | ((ImageProcessing) this).rgbpix[0] << 16
			       | ((ImageProcessing) this).rgbpix[1] << 8
			       | ((ImageProcessing) this).rgbpix[2]);
		    else
			((ImageProcessing) this).pix2
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]
			    = ((((ImageProcessing) this).pix
				[((((ImageProcessing) this).j
				   * ((ImageProcessing) this).w)
				  + ((ImageProcessing) this).i)]) & ~0xffffff
			       | ((ImageProcessing) this).rgbpix[0] << 16
			       | ((ImageProcessing) this).rgbpix[0] << 8
			       | ((ImageProcessing) this).rgbpix[0]);
		}
	    }
	} else {
	    for (((ImageProcessing) this).i = 0;
		 ((ImageProcessing) this).i < i_66_;
		 ((ImageProcessing) this).i++) {
		for (((ImageProcessing) this).j = 0;
		     ((ImageProcessing) this).j < i_66_;
		     ((ImageProcessing) this).j++) {
		    for (int i_99_ = 0; i_99_ < ((ImageProcessing) this).col;
			 i_99_ += 2) {
			int i_100_
			    = ((((ImageProcessing) this).col
				* ((((ImageProcessing) this).j + 1) * i_66_
				   + ((ImageProcessing) this).i + 1))
			       + i_99_ + ((ImageProcessing) this).dataset);
			((ImageProcessing) this).val
			    = Math.sqrt((((ImageProcessing) this).tab[i_100_]
					 * (((ImageProcessing) this).tab
					    [i_100_]))
					+ ((((ImageProcessing) this).tab
					    [i_100_ + 1])
					   * (((ImageProcessing) this).tab
					      [i_100_ + 1])));
			((ImageProcessing) this).rgbpix[i_99_ / 2]
			    = (int) Math.round(255.0
					       * ((ImageProcessing) this).val
					       / (((ImageProcessing) this).cmax
						  [i_99_]));
		    }
		    if (((ImageProcessing) this).col == 6)
			((ImageProcessing) this).pix2
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]
			    = ((((ImageProcessing) this).pix
				[((((ImageProcessing) this).j
				   * ((ImageProcessing) this).w)
				  + ((ImageProcessing) this).i)]) & ~0xffffff
			       | ((ImageProcessing) this).rgbpix[0] << 16
			       | ((ImageProcessing) this).rgbpix[1] << 8
			       | ((ImageProcessing) this).rgbpix[2]);
		    else
			((ImageProcessing) this).pix2
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]
			    = ((((ImageProcessing) this).pix
				[((((ImageProcessing) this).j
				   * ((ImageProcessing) this).w)
				  + ((ImageProcessing) this).i)]) & ~0xffffff
			       | ((ImageProcessing) this).rgbpix[0] << 16
			       | ((ImageProcessing) this).rgbpix[0] << 8
			       | ((ImageProcessing) this).rgbpix[0]);
		}
	    }
	}
	((JavaPhotoLab) ((ImageProcessing) this).app).fftmake = true;
	return MatrixToImage();
    }
    
    public void Histogram(Image img) {
	ImageToMatrix(img);
	Histogram hist = new Histogram(((ImageProcessing) this).pix,
				       ((ImageProcessing) this).w,
				       ((ImageProcessing) this).h);
	hist.setTitle("Image Histogram");
	hist.resize(600, 450);
	hist.show();
    }
    
    public Image MatrixToImage() {
	((ImageProcessing) this).app.showStatus("Reconstructing Image");
	MediaTracker tracker = new MediaTracker(this);
	((ImageProcessing) this).img3
	    = (this.createImage
	       (new MemoryImageSource(((ImageProcessing) this).w,
				      ((ImageProcessing) this).h,
				      ((ImageProcessing) this).pix2, 0,
				      ((ImageProcessing) this).w)));
	tracker.addImage(((ImageProcessing) this).img3, 0);
	try {
	    tracker.waitForID(0);
	} catch (InterruptedException ex) {
	    ((ImageProcessing) this).app.showStatus("Error: " + ex.toString());
	}
	((ImageProcessing) this).app.showStatus("Done.");
	if (((ImageProcessing) this).affiche == 1)
	    ((ImageProcessing) this).app.showStatus
		("% of final data: "
		 + (100 * ((ImageProcessing) this).nbnum
		    / (((ImageProcessing) this).w
		       * ((ImageProcessing) this).h))
		 + " %");
	((ImageProcessing) this).affiche = 0;
	return ((ImageProcessing) this).img3;
    }
    
    public Image PseudoColors(Image img) {
	ImageToMatrix(img);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]) & 0xff;
		if (((ImageProcessing) this).rgb < 64) {
		    ((ImageProcessing) this).r = 0;
		    ((ImageProcessing) this).g
			= 255 - ((ImageProcessing) this).rgb * 4;
		    ((ImageProcessing) this).b = 255;
		}
		if (((ImageProcessing) this).rgb >= 64
		    && ((ImageProcessing) this).rgb < 128) {
		    ((ImageProcessing) this).r = 0;
		    ((ImageProcessing) this).g
			= (((ImageProcessing) this).rgb - 64) * 4;
		    ((ImageProcessing) this).b
			= 255 - (((ImageProcessing) this).rgb - 64) * 4;
		}
		if (((ImageProcessing) this).rgb >= 128
		    && ((ImageProcessing) this).rgb < 192) {
		    ((ImageProcessing) this).r
			= (((ImageProcessing) this).rgb - 128) * 4;
		    ((ImageProcessing) this).g = 255;
		    ((ImageProcessing) this).b = 0;
		}
		if (((ImageProcessing) this).rgb >= 192) {
		    ((ImageProcessing) this).r = 255;
		    ((ImageProcessing) this).g
			= 255 - (((ImageProcessing) this).rgb - 192) * 4;
		    ((ImageProcessing) this).b = 0;
		}
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = ((((ImageProcessing) this).pix
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]) & ~0xffffff
		       | ((ImageProcessing) this).r << 16
		       | ((ImageProcessing) this).g << 8
		       | ((ImageProcessing) this).b);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image ButterLow(Image image, double d, int i) {
	ImageToMatrix(image);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).j++) {
		double d_101_
		    = (Math.sqrt
		       (Math.pow((double) (((ImageProcessing) this).i
					   - ((ImageProcessing) this).w / 2),
				 2.0)
			+ Math.pow((double) (((ImageProcessing) this).j
					     - ((ImageProcessing) this).h / 2),
				   2.0)));
		double d_102_;
		if (d_101_ == 0.0)
		    d_102_ = (double) i;
		else {
		    double d_103_ = d_101_ / d;
		    d_102_ = 1.0 / (1.0 + d_103_ * d_103_);
		}
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		for (((ImageProcessing) this).c = 0;
		     ((ImageProcessing) this).c < ((ImageProcessing) this).col;
		     ((ImageProcessing) this).c
			 = ((ImageProcessing) this).c + 2) {
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_102_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_102_;
		    ((ImageProcessing) this).rgbpix[(((ImageProcessing) this).c
						     / 2)]
			= (int) ((double) ((((ImageProcessing) this).rgb
					    & (((ImageProcessing) this)
					       .tabcolor
					       [(((ImageProcessing) this).c
						 / 2)]))
					   >> 16 - (((ImageProcessing) this).c
						    * 4))
				 * d_102_);
		}
		if (((ImageProcessing) this).col == 6)
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		else
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[0] << 8
			   | ((ImageProcessing) this).rgbpix[0]);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image ButterHigh(Image image, double d) {
	ImageToMatrix(image);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).j++) {
		double d_104_
		    = (Math.sqrt
		       (Math.pow((double) (((ImageProcessing) this).i
					   - ((ImageProcessing) this).w / 2),
				 2.0)
			+ Math.pow((double) (((ImageProcessing) this).j
					     - ((ImageProcessing) this).h / 2),
				   2.0)));
		double d_105_;
		if (d_104_ == 0.0)
		    d_105_ = 0.0;
		else {
		    double d_106_ = d / d_104_;
		    d_105_ = 1.0 / (1.0 + d_106_ * d_106_);
		}
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		for (((ImageProcessing) this).c = 0;
		     ((ImageProcessing) this).c < ((ImageProcessing) this).col;
		     ((ImageProcessing) this).c
			 = ((ImageProcessing) this).c + 2) {
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_105_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_105_;
		    ((ImageProcessing) this).rgbpix[(((ImageProcessing) this).c
						     / 2)]
			= (int) ((double) ((((ImageProcessing) this).rgb
					    & (((ImageProcessing) this)
					       .tabcolor
					       [(((ImageProcessing) this).c
						 / 2)]))
					   >> 16 - (((ImageProcessing) this).c
						    * 4))
				 * d_105_);
		}
		if (((ImageProcessing) this).col == 6)
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		else
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[0] << 8
			   | ((ImageProcessing) this).rgbpix[0]);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public double returnVariance(int[] tableau, int size) {
	((ImageProcessing) this).mean = returnMean(tableau, size);
	((ImageProcessing) this).z = 0.0;
	for (((ImageProcessing) this).q = 0; ((ImageProcessing) this).q < size;
	     ((ImageProcessing) this).q++)
	    ((ImageProcessing) this).z
		= (((ImageProcessing) this).z
		   + Math.pow(((double) tableau[((ImageProcessing) this).q]
			       - ((ImageProcessing) this).mean),
			      2.0));
	return ((ImageProcessing) this).z / (double) (size - 1);
    }
    
    public Image InvertColors(Image img) {
	ImageToMatrix(img);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = (((ImageProcessing) this).rgb & ~0xffffff
		       | 16777215 - ((ImageProcessing) this).rgb);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image LowPassLinear(Image img) {
	int[] filt = { 1, 1, 1, 1, 1, 1, 1, 1, 1 };
	ImageToMatrix(img);
	((ImageProcessing) this).dim = 3;
	((ImageProcessing) this).cote = 1;
	((ImageProcessing) this).total = 9;
	for (((ImageProcessing) this).i = 0;
	     (((ImageProcessing) this).i
	      < ((ImageProcessing) this).dim * ((ImageProcessing) this).dim);
	     ((ImageProcessing) this).i++)
	    ((ImageProcessing) this).matfilt[((ImageProcessing) this).i]
		= filt[((ImageProcessing) this).i];
	LinearFilter();
	return MatrixToImage();
    }
    
    public Image GrayScale(Image img) {
	ImageToMatrix(img);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		((ImageProcessing) this).r
		    = (((ImageProcessing) this).rgb & 0xff0000) >> 16;
		((ImageProcessing) this).g
		    = (((ImageProcessing) this).rgb & 0xff00) >> 8;
		((ImageProcessing) this).b
		    = ((ImageProcessing) this).rgb & 0xff;
		((ImageProcessing) this).k
		    = (((ImageProcessing) this).r + ((ImageProcessing) this).g
		       + ((ImageProcessing) this).b) / 3;
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = (((ImageProcessing) this).rgb & ~0xffffff
		       | ((ImageProcessing) this).k << 16
		       | ((ImageProcessing) this).k << 8
		       | ((ImageProcessing) this).k);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image LowPass(Image image, double d) {
	ImageToMatrix(image);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).j++) {
		double d_107_
		    = (Math.sqrt
		       (Math.pow((double) (((ImageProcessing) this).i
					   - ((ImageProcessing) this).w / 2),
				 2.0)
			+ Math.pow((double) (((ImageProcessing) this).j
					     - ((ImageProcessing) this).w / 2),
				   2.0)));
		double d_108_;
		if (d_107_ > d)
		    d_108_ = 0.0;
		else
		    d_108_ = 1.0;
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		for (((ImageProcessing) this).c = 0;
		     ((ImageProcessing) this).c < ((ImageProcessing) this).col;
		     ((ImageProcessing) this).c
			 = ((ImageProcessing) this).c + 2) {
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_108_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_108_;
		    ((ImageProcessing) this).rgbpix[(((ImageProcessing) this).c
						     / 2)]
			= (int) ((double) ((((ImageProcessing) this).rgb
					    & (((ImageProcessing) this)
					       .tabcolor
					       [(((ImageProcessing) this).c
						 / 2)]))
					   >> 16 - (((ImageProcessing) this).c
						    * 4))
				 * d_108_);
		}
		if (((ImageProcessing) this).col == 6)
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		else
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[0] << 8
			   | ((ImageProcessing) this).rgbpix[0]);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image HighPass(Image image, double d) {
	ImageToMatrix(image);
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).w;
		 ((ImageProcessing) this).j++) {
		double d_109_
		    = (Math.sqrt
		       (Math.pow((double) (((ImageProcessing) this).i
					   - ((ImageProcessing) this).w / 2),
				 2.0)
			+ Math.pow((double) (((ImageProcessing) this).j
					     - ((ImageProcessing) this).w / 2),
				   2.0)));
		double d_110_;
		if (d_109_ < d)
		    d_110_ = 0.0;
		else
		    d_110_ = 1.0;
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		for (((ImageProcessing) this).c = 0;
		     ((ImageProcessing) this).c < ((ImageProcessing) this).col;
		     ((ImageProcessing) this).c
			 = ((ImageProcessing) this).c + 2) {
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 0 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_110_;
		    ((ImageProcessing) this).tab
			[((((ImageProcessing) this).col
			   * (((((ImageProcessing) this).j + 1)
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i + 1))
			  + 1 + ((ImageProcessing) this).c
			  + ((ImageProcessing) this).dataset)]
			*= d_110_;
		    ((ImageProcessing) this).rgbpix[(((ImageProcessing) this).c
						     / 2)]
			= (int) ((double) ((((ImageProcessing) this).rgb
					    & (((ImageProcessing) this)
					       .tabcolor
					       [(((ImageProcessing) this).c
						 / 2)]))
					   >> 16 - (((ImageProcessing) this).c
						    * 4))
				 * d_110_);
		}
		if (((ImageProcessing) this).col == 6)
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[1] << 8
			   | ((ImageProcessing) this).rgbpix[2]);
		else
		    ((ImageProcessing) this).pix2
			[((((ImageProcessing) this).j
			   * ((ImageProcessing) this).w)
			  + ((ImageProcessing) this).i)]
			= ((((ImageProcessing) this).pix
			    [((((ImageProcessing) this).j
			       * ((ImageProcessing) this).w)
			      + ((ImageProcessing) this).i)]) & ~0xffffff
			   | ((ImageProcessing) this).rgbpix[0] << 16
			   | ((ImageProcessing) this).rgbpix[0] << 8
			   | ((ImageProcessing) this).rgbpix[0]);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: " + (100 * ((ImageProcessing) this).i
				   / ((ImageProcessing) this).w) + " % done.");
	}
	return MatrixToImage();
    }
    
    public Image ContrastStretching(Image img) {
	ImageToMatrix(img);
	int rmax = 0;
	int gmax = 0;
	int bmax = 0;
	int rmin = 255;
	int gmin = 255;
	int bmin = 255;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		int rgb2 = (((ImageProcessing) this).rgb & 0xff0000) >> 16;
		if (rgb2 > rmax)
		    rmax = rgb2;
		if (rgb2 < rmin)
		    rmin = rgb2;
		rgb2 = (((ImageProcessing) this).rgb & 0xff00) >> 8;
		if (rgb2 > gmax)
		    gmax = rgb2;
		if (rgb2 < gmin)
		    gmin = rgb2;
		rgb2 = ((ImageProcessing) this).rgb & 0xff;
		if (rgb2 > bmax)
		    bmax = rgb2;
		if (rgb2 < bmin)
		    bmin = rgb2;
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: "
		 + 50 * ((ImageProcessing) this).i / ((ImageProcessing) this).w
		 + " % done.");
	}
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		int rgb2 = (((ImageProcessing) this).rgb & 0xff0000) >> 16;
		((ImageProcessing) this).r
		    = 255 * (rgb2 - rmin) / (rmax - rmin);
		rgb2 = (((ImageProcessing) this).rgb & 0xff00) >> 8;
		((ImageProcessing) this).g
		    = 255 * (rgb2 - gmin) / (gmax - gmin);
		rgb2 = ((ImageProcessing) this).rgb & 0xff;
		((ImageProcessing) this).b
		    = 255 * (rgb2 - bmin) / (bmax - bmin);
		((ImageProcessing) this).pix2[((((ImageProcessing) this).j
						* ((ImageProcessing) this).w)
					       + ((ImageProcessing) this).i)]
		    = (((ImageProcessing) this).rgb & ~0xffffff
		       | ((ImageProcessing) this).r << 16
		       | ((ImageProcessing) this).g << 8
		       | ((ImageProcessing) this).b);
	    }
	    ((ImageProcessing) this).app.showStatus
		("Processing: "
		 + (50 + (50 * ((ImageProcessing) this).i
			  / ((ImageProcessing) this).w))
		 + " % done.");
	}
	return MatrixToImage();
    }
    
    public boolean isGrayscale() {
	boolean test = true;
	for (((ImageProcessing) this).i = 0; ((ImageProcessing) this).i < 3;
	     ((ImageProcessing) this).i++)
	    ((ImageProcessing) this).cmax[((ImageProcessing) this).i] = 0.0;
	for (((ImageProcessing) this).i = 0;
	     ((ImageProcessing) this).i < ((ImageProcessing) this).w;
	     ((ImageProcessing) this).i++) {
	    for (((ImageProcessing) this).j = 0;
		 ((ImageProcessing) this).j < ((ImageProcessing) this).h;
		 ((ImageProcessing) this).j++) {
		((ImageProcessing) this).rgb
		    = (((ImageProcessing) this).pix
		       [((((ImageProcessing) this).j
			  * ((ImageProcessing) this).w)
			 + ((ImageProcessing) this).i)]);
		((ImageProcessing) this).rtmp
		    = (((ImageProcessing) this).rgb & 0xff0000) >> 16;
		((ImageProcessing) this).gtmp
		    = (((ImageProcessing) this).rgb & 0xff00) >> 8;
		((ImageProcessing) this).btmp
		    = ((ImageProcessing) this).rgb & 0xff;
		test = (test
			&& (((ImageProcessing) this).rtmp
			    == ((ImageProcessing) this).gtmp)
			&& (((ImageProcessing) this).rtmp
			    == ((ImageProcessing) this).btmp));
	    }
	}
	return test;
    }
}
